var TObject={
	$ClassName: "TObject",
	$Parent: null,
	ClassName: function (s) { return s.$ClassName },
	ClassType: function (s) { return s },
	ClassParent: function (s) { return s.$Parent },
	$Init: function () {},
	Create: function (s) { return s },
	Destroy: function (s) { for (var prop in s) if (s.hasOwnProperty(prop)) delete s.prop },
	Destroy$: function(s) { return s.ClassType.Destroy(s) },
	Free: function (s) { if (s!==null) s.ClassType.Destroy(s) }
}
function StrReplace(s,o,n) { return o?s.replace(new RegExp(StrRegExp(o), "g"), n):s }
function StrRegExp(s) { return s.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g, "\\$&") }
function StrEndsWith(s,e) { return s.substr(s.length-e.length)==e }
function StrBefore(s,d) { if (!d) return s; var p=s.indexOf(d); return (p<0)?s:s.substr(0, p) }
var Exception={
	$ClassName: "Exception",
	$Parent: TObject,
	$Init: function () { var FMessage="" },
	Create: function (s,Msg) { s.FMessage=Msg; return s }
}
function stringRepeat(s, n) {
    if (n<1) return '';
    var r = '';
    while (n > 0) {
        if (n & 1) r += s;
        n >>= 1, s += s;
    };
    return r;
};
function DupeString(s,n) { return stringRepeat(s,n) }
function $W(e) { return e.ClassType?e:Exception.Create($New(Exception),e.constructor.name+", "+e.message) }
function $StrSet(s,i,v,z) {
	if (i<1) throw Exception.Create($New(Exception),"Lower bound exceeded! Index "+i.toString()+z);
	if (i>s.length) throw Exception.Create($New(Exception),"Upper bound exceeded! Index "+i.toString()+z);
	return s.substring(0,i-1)+v+s.substring(i);
}
function $New(c) { var i={ClassType:c}; c.$Init(i); return i }
function $Is(o,c) {
	if (o===null) return false;
	return $Inh(o.ClassType,c);
}
;
function $Inh(s,c) {
	if (s===null) return false;
	while ((s)&&(s!==c)) s=s.$Parent;
	return (s)?true:false;
}
;
function $Extend(base, sub, props) {
	function F() {};
	F.prototype = base.prototype;
	sub.prototype = new F();
	sub.prototype.constructor = sub;
	for (var n in props) {
		if (props.hasOwnProperty(n)) {
			sub.prototype[n]=props[n];
		}
	}
}
function $AsIntf(o,i) {
	if (o===null) return null;
	var r = o.ClassType.$Intf[i].map(function (e) {
		return function () {
			var arg=Array.prototype.slice.call(arguments);
			arg.splice(0,0,o);
			return e.apply(o, arg);
		}
	});
	r.O = o;
	return r;
}
;
function $As(o,c) {
	if ((o===null)||$Is(o,c)) return o;
	throw Exception.Create($New(Exception),"Cannot cast instance of type \""+o.ClassType.$ClassName+"\" to class \""+c.$ClassName+"\"");
}
function TranslateFile(InputFile, OutputFile$1) {
   var Result = false;
   var InputName = "",
      Data = null,
      InputText = "",
      Translator = null,
      OutputText = "";
   InputName = StrBefore(InputFile,".d.ts");
   if (InputFile==InputName) {
      InputFile+=".d.ts";
   }
   Data = FileSystem.readFileSync(InputFile);
   if (!Data) {
      return Result;
   }
   InputText = Data.toString("utf8");
   Translator = TTranslator.Create$9($New(TTranslator));
   Translator.Name = InputName;
   OutputText = TTranslator.Translate(Translator,InputText);
   Result = OutputText!="";
   if (OutputText.length>5) {
      FileSystem.writeFileSync(OutputFile$1,OutputText);
   }
   Translator = null;
   return Result
};
function TranslateFile$1(InputFile$1) {
   var Result = false;
   Result = TranslateFile(InputFile$1,StrBefore(InputFile$1,".d.ts")+".pas");
   return Result
};
function TranslateDirectory(Directory) {
   var Success = [];
   FileSystem.readdir(Directory,function (err, files) {
      var a$113 = 0;
      var File = "";
      var $temp1;
      for(a$113=0,$temp1=files.length;a$113<$temp1;a$113++) {
         File = files[a$113];
         if (!StrEndsWith(File,".d.ts")) {
            continue;
         }
         if (TranslateFile$1(Directory+File)) {
            Success.push(File);
         } else {
            /* null */
         }
      }
   });
};
function ProcesAllUrls() {
   var URLs = function () {
         for (var r=[],i=0; i<42; i++) r.push("");
         return r
      }(),
      a$114 = 0;
   var URL = "";
   URLs = ["abs\/abs.d.ts", "absolute\/absolute.d.ts", "accounting\/accounting.d.ts", "acc-wizard\/acc-wizard.d.ts", "amazon-product-api\/amazon-product-api.d.ts", "amcharts\/AmCharts.d.ts", "amplifyjs\/amplifyjs.d.ts", "box2d\/box2dweb.d.ts", "browserify\/browserify.d.ts", "d3\/d3.d.ts", "devextreme\/devextreme.d.ts", "dojo\/dijit.d.ts", "dojo\/dojo.d.ts", "easeljs\/easeljs.d.ts", "ember\/ember.d.ts", "express\/express.d.ts", "fabricjs\/fabricjs.d.ts", "gruntjs\/gruntjs.d.ts", "hapi\/hapi.d.ts", "jquery\/jquery.d.ts", "jquerymobile\/jquerymobile.d.ts", "kendo-ui\/kendo-ui.d.ts", "leapmotionTS\/LeapMotionTS.d.ts", "linq\/linq.d.ts", "matter-js\/matter-js.d.ts", "office-js\/office-js.d.ts", "openlayers\/openlayers.d.ts", "phantom\/phantom.d.ts", "phantomjs\/phantomjs.d.ts", "phonegap\/phonegap.d.ts", "plottable\/plottable.d.ts", "preloadjs\/preloadjs.d.ts", "socket.io\/socket.io.d.ts", "soundjs\/soundjs.d.ts", "titanium\/titanium.d.ts", "tweenjs\/tweenjs.d.ts", "typescript\/typescript.d.ts", "ui-grid\/ui-grid.d.ts", "webix\/webix.d.ts", "winjs\/winjs.d.ts", "winrt\/winrt.d.ts", "youtube\/youtube.d.ts"];
   for(a$114=0;a$114<=41;a$114++) {
      URL = URLs[a$114];
      LoadAndTranslate("\/DefinitelyTyped\/DefinitelyTyped\/master\/"+URL);
   }
};
function OutputAst(InputFile$2) {
   if (InputFile$2==StrBefore(InputFile$2,".d.ts")) {
      InputFile$2+=".d.ts";
   }
   FileSystem.readFile(InputFile$2,function (err$1, data) {
      var InputText$1 = "",
         SourceFile = null;
      InputText$1 = data.toString("utf8");
      SourceFile = TypeScriptExport.createSourceFile(InputFile$2,InputText$1,2,true);
      Delint(SourceFile);
   });
};
function LoadAndTranslate(URL$1) {
   var Https = null,
      Options = null,
      Translator$1 = null,
      ClientRequest = null;
   Https = https();
   Options = new Object();
   Options.hostname = "raw.githubusercontent.com";
   Options.path = URL$1;
   console.log("Fetching: "+URL$1);
   Translator$1 = TTranslator.Create$9($New(TTranslator));
   ClientRequest = Https.get(Options,function (EventEmitter) {
      var InputText$2 = "",
         URLParts = [],
         InputName$1 = "",
         OutputFile = "";
      InputText$2 = "";
      URLParts = (URL$1).split("\/");
      InputName$1 = StrBefore(URLParts[(URLParts.length-1)],".d.ts");
      OutputFile = InputName$1+".pas";
      EventEmitter.on("data",function (ChunkText) {
         InputText$2+=String(ChunkText);
      });
      EventEmitter.on("end",function (_implicit_data) {
         var OutputText$1 = "";
         console.log("Translating: "+InputName$1);
         Translator$1.Name = InputName$1;
         OutputText$1 = TTranslator.Translate(Translator$1,InputText$2);
         console.log("Writing: "+OutputFile);
         if (OutputText$1.length>5) {
            FileSystem.writeFile(OutputFile,OutputText$1,function (Error$1) {
            });
         }
      });
   });
   ClientRequest.on("error",function (Error$2) {
      console.log("Error: ",Error$2);
   });
};
function Delint(SourceFile$1) {
   DelintNode(SourceFile$1);
};
function DelintNode(Node) {
   var Result = undefined;
   switch (Node.kind) {
      case 9 :
         console.log(Node.text);
         break;
      case 69 :
         console.log(Node.text);
         break;
      case 151 :
         console.log(Node.text);
         break;
      case 122 :
         console.log("declare");
         break;
      case 135 :
         console.log(Node.left);
         break;
      default :
         console.log(Node.kind);
   }
   TypeScriptExport.forEachChild(Node,DelintNode);
   return Result
};
function JError() {
}
$Extend(Object,JError,
   {
   });

function Copy$TWriteFileOptions(s,d) {
   d.encoding=s.encoding;
   d.mode=s.mode;
   d.flag=s.flag;
   return d;
}
function Clone$TWriteFileOptions($) {
   return {
      encoding:$.encoding,
      mode:$.mode,
      flag:$.flag
   }
}
function Copy$TwatchOptions(s,d) {
   d.persistent=s.persistent;
   return d;
}
function Clone$TwatchOptions($) {
   return {
      persistent:$.persistent
   }
}
function Copy$TWatchFileOptions(s,d) {
   d.persistent=s.persistent;
   d.interval=s.interval;
   return d;
}
function Clone$TWatchFileOptions($) {
   return {
      persistent:$.persistent,
      interval:$.interval
   }
}
function Copy$TWatchFileListenerObject(s,d) {
   d.curr=s.curr;
   d.prev=s.prev;
   return d;
}
function Clone$TWatchFileListenerObject($) {
   return {
      curr:$.curr,
      prev:$.prev
   }
}
function Copy$TReadFileSyncOptions(s,d) {
   d.encoding=s.encoding;
   d.flag=s.flag;
   return d;
}
function Clone$TReadFileSyncOptions($) {
   return {
      encoding:$.encoding,
      flag:$.flag
   }
}
function Copy$TReadFileOptions(s,d) {
   d.encoding=s.encoding;
   d.flag=s.flag;
   return d;
}
function Clone$TReadFileOptions($) {
   return {
      encoding:$.encoding,
      flag:$.flag
   }
}
function Copy$TcreateWriteStreamOptions(s,d) {
   d.flags=s.flags;
   d.encoding=s.encoding;
   d.string_=s.string_;
   return d;
}
function Clone$TcreateWriteStreamOptions($) {
   return {
      flags:$.flags,
      encoding:$.encoding,
      string_:$.string_
   }
}
function Copy$TcreateReadStreamOptions(s,d) {
   d.bufferSize=s.bufferSize;
   d.encoding=s.encoding;
   d.fd=s.fd;
   d.mode=s.mode;
   d.flags=s.flags;
   return d;
}
function Clone$TcreateReadStreamOptions($) {
   return {
      bufferSize:$.bufferSize,
      encoding:$.encoding,
      fd:$.fd,
      mode:$.mode,
      flags:$.flags
   }
}
function Copy$TAppendFileOptions(s,d) {
   d.encoding=s.encoding;
   d.mode=s.mode;
   d.flag=s.flag;
   return d;
}
function Clone$TAppendFileOptions($) {
   return {
      encoding:$.encoding,
      mode:$.mode,
      flag:$.flag
   }
}
function fs() {
   var Result = null;
   Result = require("fs");
   return Result
};
function stream() {
   var Result = null;
   Result = require("stream");
   return Result
};
function events() {
   var Result = null;
   Result = require("events");
   return Result
};
function https() {
   var Result = null;
   Result = require("https");
   return Result
};
var TServer_address_result_object_tls = {
   $ClassName:"TServer_address_result_object_tls",$Parent:TObject
   ,$Init:function ($) {
      TObject.$Init($);
      $.port = 0;
      $.family = $.address = "";
   }
   ,Destroy:TObject.Destroy
};
var TServer_addContext_credentials_object = {
   $ClassName:"TServer_addContext_credentials_object",$Parent:TObject
   ,$Init:function ($) {
      TObject.$Init($);
      $.key = $.cert = $.ca = "";
   }
   ,Destroy:TObject.Destroy
};
function tls() {
   var Result = null;
   Result = require("tls");
   return Result
};
var TClearTextStream_getCipher_object = {
   $ClassName:"TClearTextStream_getCipher_object",$Parent:TObject
   ,$Init:function ($) {
      TObject.$Init($);
      $.name = $.version = "";
   }
   ,Destroy:TObject.Destroy
};
var TClearTextStream_address_object = {
   $ClassName:"TClearTextStream_address_object",$Parent:TObject
   ,$Init:function ($) {
      TObject.$Init($);
      $.port = 0;
      $.family = $.address = "";
   }
   ,Destroy:TObject.Destroy
};
function crypto$1() {
   var Result = null;
   Result = require("crypto");
   return Result
};
function Copy$TCreateServerOptions(s,d) {
   d.allowHalfOpen=s.allowHalfOpen;
   return d;
}
function Clone$TCreateServerOptions($) {
   return {
      allowHalfOpen:$.allowHalfOpen
   }
}
function Copy$TCreateConnectionOptions(s,d) {
   d.allowHalfOpen=s.allowHalfOpen;
   return d;
}
function Clone$TCreateConnectionOptions($) {
   return {
      allowHalfOpen:$.allowHalfOpen
   }
}
function Copy$TConnectOptions(s,d) {
   d.allowHalfOpen=s.allowHalfOpen;
   return d;
}
function Clone$TConnectOptions($) {
   return {
      allowHalfOpen:$.allowHalfOpen
   }
}
function net() {
   var Result = null;
   Result = require("net");
   return Result
};
function Copy$JSocketOptions(s,d) {
   d.fd=s.fd;
   d.type=s.type;
   d.allowHalfOpen=s.allowHalfOpen;
   return d;
}
function Clone$JSocketOptions($) {
   return {
      fd:$.fd,
      type:$.type,
      allowHalfOpen:$.allowHalfOpen
   }
}
var JServerAddressResult = {
   $ClassName:"JServerAddressResult",$Parent:TObject
   ,$Init:function ($) {
      TObject.$Init($);
      $.port = 0;
      $.family = $.address = "";
   }
   ,Destroy:TObject.Destroy
};
function http() {
   var Result = null;
   Result = require("http");
   return Result
};
var TDiagnosticCategory = [ "Warning", "Error", "Message" ];
function Copy$TConfigFileResult(s,d) {
   d.config=s.config;
   d.error=s.error;
   return d;
}
function Clone$TConfigFileResult($) {
   return {
      config:$.config,
      error:$.error
   }
}
var TTranslator = {
   $ClassName:"TTranslator",$Parent:TObject
   ,$Init:function ($) {
      TObject.$Init($);
      $.NeedsSemicolon = false;
      $.Name = "";
      $.FDeclarations = [];
      $.FImports = [];
      $.FInterfaces = [];
      $.FModules = [];
      $.FScanner = $.FSourceFile = null;
   }
   ,a$3:function(Self) {
      return Self.FScanner.getTokenText();
   }
   ,a$2:function(Self) {
      return Self.FScanner.getToken();
   }
   ,AssumeIdentifier:function(Self, AdditionalToken) {
      if (!(Self.FScanner.isIdentifier()||AdditionalToken.indexOf(TTranslator.a$2(Self))>=0)) {
         TTranslator.HandleScanError(Self,0);
      }
   }
   ,AssumeToken$1:function(Self, Tokens) {
      if (!(Tokens.indexOf(TTranslator.a$2(Self))>=0)) {
         TTranslator.HandleScanError(Self,0);
      }
   }
   ,AssumeToken:function(Self, Token) {
      if (TTranslator.a$2(Self)!=Token) {
         TTranslator.HandleScanError(Self,Token);
      }
   }
   ,BuildPascalHeader:function(Self) {
      var Result = "";
      var a$282 = 0;
      var Import = null,
         a$283 = 0;
      var Module$1 = null,
         a$284 = 0;
      var Interface = null,
         a$285 = 0;
      var Declaration = null;
      var a$286 = [],
          a$287 = [],
          a$288 = [];
      Result = "";
      if (Self.FImports.length+Self.FModules.length+Self.FInterfaces.length+Self.FDeclarations.length==0) {
         return Result;
      }
      Result = "unit "+GetUnitName(Self.Name)+";"+"\r\n"+"\r\n";
      Result+="interface"+"\r\n"+"\r\n";
      a$288 = Self.FImports;
      var $temp2;
      for(a$282=0,$temp2=a$288.length;a$282<$temp2;a$282++) {
         Import = a$288[a$282];
         Result = Result+TCustomDeclaration.GetAsCode$(Import);
      }
      a$287 = Self.FModules;
      var $temp3;
      for(a$283=0,$temp3=a$287.length;a$283<$temp3;a$283++) {
         Module$1 = a$287[a$283];
         Result = Result+TCustomDeclaration.GetAsCode$(Module$1);
      }
      if (Self.FInterfaces.length>0) {
         var a$289 = [];
         Result+="type"+"\r\n";
         TCustomDeclaration.BeginIndention(TCustomDeclaration);
         a$289 = Self.FInterfaces;
         var $temp4;
         for(a$284=0,$temp4=a$289.length;a$284<$temp4;a$284++) {
            Interface = a$289[a$284];
            Result = Result+TCustomDeclaration.GetAsCode$(Interface);
         }
         TCustomDeclaration.EndIndention(TCustomDeclaration);
      }
      a$286 = Self.FDeclarations;
      var $temp5;
      for(a$285=0,$temp5=a$286.length;a$285<$temp5;a$285++) {
         Declaration = a$286[a$285];
         Result = Result+TCustomDeclaration.GetAsCode$(Declaration);
      }
      return Result
   }
   ,Create$9:function(Self) {
      Self.NeedsSemicolon = false;
      return Self
   }
   ,HandleScanError:function(Self, Expected) {
      var LineChar = null,
         Text$1 = "";
      LineChar = TypeScriptExport.getLineAndCharacterOfPosition(Self.FSourceFile,Self.FScanner.getTokenPos());
      Text$1 = ("Unknown token \""+TTranslator.a$3(Self).toString()+"\" in this context ("+(LineChar.line+1).toString()+":"+(LineChar.character+1).toString()+")");
      if (Expected>0) {
         Text$1+=("; Expected ("+Expected.toString()+")");
      }
      console.trace("Error in "+Self.Name);
      throw Exception.Create($New(Exception),Text$1);
   }
   ,ReadAmbientBinding:function(Self) {
      var Result = null;
      TTranslator.AssumeIdentifier(Self,[]);
      Result = TCustomDeclaration.Create$10$($New(TAmbientBinding),$AsIntf(Self,"IDeclarationOwner"));
      Result.Name = TTranslator.a$3(Self);
      if (TTranslator.ReadToken$1(Self,54,false)) {
         Result.Type = TTranslator.ReadTypeAnnotation(Self);
      }
      if (Self.NeedsSemicolon) {
         TTranslator.AssumeToken$1(Self,[23, 24].slice());
      }
      return Result
   }
   ,ReadAmbientBindingList:function(Self, AmbientBindingList$1) {
      do {
         AmbientBindingList$1.push(TTranslator.ReadAmbientBinding(Self));
         if (TTranslator.a$2(Self)==23) {
            break;
         }
         if (TTranslator.a$2(Self)!=24) {
            break;
         }
         if (!TTranslator.ReadIdentifier(Self,false)) {
            break;
         }
      } while (!(TTranslator.a$2(Self)==23||(!Self.FScanner.isIdentifier())||(!Self.NeedsSemicolon)&&(!Self.FScanner.isIdentifier())));
   }
   ,ReadAmbientClassBodyElement:function(Self) {
      var Result = null;
      var Visibility$3 = 0,
         IsStatic$3 = false;
      TTranslator.AssumeIdentifier(Self,[121, 110, 111, 112, 113].slice());
      if (TTranslator.a$2(Self)==121) {
         return TTranslator.ReadAmbientConstructorDeclaration(Self);
      }
      Visibility$3 = 0;
      switch (TTranslator.a$2(Self)) {
         case 112 :
            Visibility$3 = 0;
            TTranslator.ReadIdentifier$1(Self,[113].slice(),true);
            break;
         case 111 :
            Visibility$3 = 1;
            TTranslator.ReadIdentifier$1(Self,[113].slice(),true);
            break;
         case 110 :
            Visibility$3 = 2;
            TTranslator.ReadIdentifier$1(Self,[113].slice(),true);
            break;
      }
      IsStatic$3 = TTranslator.a$2(Self)==113;
      if (IsStatic$3) {
         TTranslator.ReadIdentifier(Self,true);
      }
      Result = TTranslator.ReadAmbientPropertyMemberDeclaration(Self);
      $As(Result,TAmbientPropertyMemberDeclaration).IsStatic = IsStatic$3;
      $As(Result,TAmbientPropertyMemberDeclaration).Visibility = Visibility$3;
      if (Self.NeedsSemicolon) {
         TTranslator.AssumeToken$1(Self,[23, 16].slice());
      }
      return Result
   }
   ,ReadAmbientClassDeclaration:function(Self) {
      var Result = null;
      var ClassDeclarationTokens = [],
         ClassDeclarationTokens = [83, 106, 15, 25].slice();
      var ClassElementTokens = [],
         ClassElementTokens = [121, 110, 111, 112, 113, 16, 23].slice();
      TTranslator.AssumeToken(Self,73);
      Result = TCustomDeclaration.Create$10$($New(TAmbientClassDeclaration),$AsIntf(Self,"IDeclarationOwner"));
      TTranslator.ReadIdentifier(Self,true);
      Result.Name = TTranslator.a$3(Self);
      TTranslator.ReadToken$2(Self,ClassDeclarationTokens,true);
      if (TTranslator.a$2(Self)==25) {
         ClassDeclarationTokens.push(25);
         do {
            Result.TypeParameters.push(TTranslator.ReadTypeParameter(Self));
         } while (!(TTranslator.a$2(Self)!=24));
         TTranslator.AssumeToken(Self,27);
         TTranslator.ReadToken$2(Self,ClassDeclarationTokens,true);
      }
      if (TTranslator.a$2(Self)==83) {
         TTranslator.ReadIdentifier(Self,true);
         Result.Extends.push(TTranslator.ReadTypeReference(Self));
      }
      if (TTranslator.a$2(Self)==106) {
         TTranslator.ReadIdentifier(Self,true);
         Result.Implements.push(TTranslator.ReadIdentifierPath(Self));
         while (TTranslator.a$2(Self)==24) {
            TTranslator.ReadIdentifier(Self,true);
            Result.Implements.push(TTranslator.ReadIdentifierPath(Self));
         }
      }
      TTranslator.AssumeToken(Self,15);
      TTranslator.ReadIdentifier$1(Self,ClassElementTokens,false);
      while (TTranslator.a$2(Self)!=16) {
         Result.Members.push(TTranslator.ReadAmbientClassBodyElement(Self));
         if (TTranslator.a$2(Self)==23) {
            TTranslator.ReadIdentifier$1(Self,ClassElementTokens,false);
         }
      }
      TTranslator.AssumeToken(Self,16);
      return Result
   }
   ,ReadAmbientConstructorDeclaration:function(Self) {
      var Result = null;
      TTranslator.AssumeToken(Self,121);
      TTranslator.ReadToken$1(Self,17,true);
      Result = TCustomDeclaration.Create$10$($New(TAmbientConstructorDeclaration),$AsIntf(Self,"IDeclarationOwner"));
      while (TTranslator.ReadIdentifier$1(Self,[22].slice(),false)) {
         Result.ParameterList.push(TTranslator.ReadFunctionParameter(Self));
         TTranslator.AssumeToken$1(Self,[24, 18, 23].slice());
         if (TTranslator.a$2(Self)==18) {
            break;
         }
      }
      TTranslator.AssumeToken$1(Self,[18, 23].slice());
      if (TTranslator.a$2(Self)!=23) {
         TTranslator.ReadToken$1(Self,23,true);
      }
      return Result
   }
   ,ReadAmbientDeclaration:function(Self) {
      var Result = null;
      TTranslator.AssumeToken(Self,122);
      Result = TCustomDeclaration.Create$10$($New(TAmbientDeclaration),$AsIntf(Self,"IDeclarationOwner"));
      TTranslator.ReadToken$2(Self,[102, 108, 74, 87, 73, 81, 125, 126].slice(),true);
      switch (TTranslator.a$2(Self)) {
         case 102 :
         case 108 :
         case 74 :
            Result.Variables.push(TTranslator.ReadAmbientVariableDeclaration(Self));
            break;
         case 87 :
            Result.Functions.push(TTranslator.ReadAmbientFunctionDeclaration(Self));
            break;
         case 73 :
            Result.Classes.push(TTranslator.ReadAmbientClassDeclaration(Self));
            break;
         case 81 :
            Result.Enums.push(TTranslator.ReadAmbientEnumDeclaration(Self));
            break;
         case 125 :
            Result.Modules.push(TTranslator.ReadAmbientModuleDeclaration(Self));
            break;
         case 126 :
            Result.Namespaces.push(TTranslator.ReadAmbientNamespaceDeclaration(Self));
            break;
      }
      return Result
   }
   ,ReadAmbientEnumDeclaration:function(Self) {
      var Result = null;
      Result = TTranslator.ReadEnumerationDeclaration(Self);
      return Result
   }
   ,ReadAmbientFunctionDeclaration:function(Self) {
      var Result = null;
      TTranslator.AssumeToken(Self,87);
      Result = TCustomDeclaration.Create$10$($New(TAmbientFunctionDeclaration),$AsIntf(Self,"IDeclarationOwner"));
      TTranslator.ReadIdentifier(Self,true);
      Result.Name = TTranslator.a$3(Self);
      TTranslator.ReadToken$2(Self,[17, 25].slice(),true);
      Result.CallSignature = TTranslator.ReadCallSignature(Self);
      if (Self.NeedsSemicolon) {
         TTranslator.AssumeToken$1(Self,[23].slice());
      }
      return Result
   }
   ,ReadAmbientModuleDeclaration:function(Self) {
      var Result = null;
      var ModuleTokens = [],
         ModuleTokens = [82, 102, 108, 74, 132, 87, 73, 107, 81, 125, 126, 89, 16, 23].slice();
      var IsExport$1 = false,
         Variable = null;
      TTranslator.AssumeToken(Self,125);
      Result = TCustomDeclaration.Create$10$($New(TAmbientModuleDeclaration),$AsIntf(Self,"IDeclarationOwner"));
      TTranslator.ReadIdentifier$1(Self,[9].slice(),true);
      Result.IdentifierPath = TTranslator.ReadIdentifierPath(Self);
      TTranslator.AssumeToken(Self,15);
      TTranslator.ReadToken$2(Self,ModuleTokens,true);
      while (TTranslator.a$2(Self)!=16) {
         IsExport$1 = TTranslator.a$2(Self)==82;
         if (IsExport$1) {
            TTranslator.ReadToken$2(Self,ModuleTokens.concat([77, 56]),true);
            if (TTranslator.a$2(Self)==77) {
               IsExport$1 = false;
               TTranslator.ReadIdentifier$1(Self,[73].slice(),true);
               if (TTranslator.a$2(Self)!=73) {
                  TTranslator.ReadToken$2(Self,ModuleTokens,true);
               }
            }
            if (TTranslator.a$2(Self)==56) {
               IsExport$1 = false;
               TTranslator.ReadIdentifier(Self,false);
               TTranslator.ReadIdentifierPath(Self);
               continue;
            }
         }
         switch (TTranslator.a$2(Self)) {
            case 102 :
            case 108 :
               Result.Variables.push(TTranslator.ReadAmbientVariableDeclaration(Self));
               break;
            case 74 :
               TTranslator.ReadIdentifier$1(Self,[81].slice(),false);
               if (TTranslator.a$2(Self)==81) {
                  Result.Enums.push(TTranslator.ReadAmbientEnumDeclaration(Self));
               } else {
                  Variable = TCustomDeclaration.Create$10$($New(TAmbientVariableDeclaration),$AsIntf(Self,"IDeclarationOwner"));
                  Variable.IsConst = true;
                  TTranslator.ReadAmbientBindingList(Self,Variable.AmbientBindingList);
                  Result.Variables.push(Variable);
               }
               TTranslator.ReadToken$2(Self,ModuleTokens,true);
               break;
            case 132 :
               Result.TypeAliases.push(TTranslator.ReadTypeAliasDeclaration(Self));
               break;
            case 87 :
               Result.Functions.push(TTranslator.ReadAmbientFunctionDeclaration(Self));
               break;
            case 126 :
               Result.Namespaces.push(TTranslator.ReadNamespaceDeclaration(Self));
               TTranslator.ReadToken$2(Self,ModuleTokens,true);
               break;
            case 73 :
               Result.Classes.push(TTranslator.ReadClassDeclaration(Self));
               TTranslator.ReadToken$2(Self,ModuleTokens,true);
               break;
            case 125 :
               Result.Modules.push(TTranslator.ReadAmbientModuleDeclaration(Self));
               TTranslator.ReadToken$2(Self,ModuleTokens,true);
               break;
            case 107 :
               Result.Interfaces.push(TTranslator.ReadInterfaceDeclaration(Self));
               TTranslator.ReadToken$2(Self,ModuleTokens,true);
               break;
            case 89 :
               TTranslator.ReadImportDeclaration(Self);
               if (!Self.NeedsSemicolon) {
                  TTranslator.ReadToken$2(Self,ModuleTokens,true);
               }
               break;
            case 81 :
               TTranslator.ReadEnumerationDeclaration(Self);
               TTranslator.ReadToken$2(Self,ModuleTokens,true);
               break;
         }
         if (TTranslator.a$2(Self)==23) {
            TTranslator.ReadToken$2(Self,ModuleTokens,true);
         }
      }
      TTranslator.AssumeToken(Self,16);
      return Result
   }
   ,ReadAmbientNamespaceDeclaration:function(Self) {
      var Result = null;
      var AmbientNamespaceTokens = [],
         AmbientNamespaceTokens = [73, 122, 82, 81, 89, 87, 107, 102, 23, 132, 16].slice();
      var IsExport$2 = false;
      TTranslator.AssumeToken(Self,126);
      TTranslator.ReadIdentifier$1(Self,[9].slice(),true);
      Result = TCustomDeclaration.Create$10$($New(TAmbientNamespaceDeclaration),$AsIntf(Self,"IDeclarationOwner"));
      Result.Name = TTranslator.ReadIdentifierPath(Self);
      TTranslator.AssumeToken(Self,15);
      TTranslator.ReadToken$2(Self,AmbientNamespaceTokens,true);
      while (TTranslator.a$2(Self)!=16) {
         IsExport$2 = TTranslator.a$2(Self)==82;
         if (IsExport$2) {
            TTranslator.ReadToken$2(Self,AmbientNamespaceTokens,true);
         }
         switch (TTranslator.a$2(Self)) {
            case 73 :
               Result.Classes.push(TTranslator.ReadAmbientClassDeclaration(Self));
               break;
            case 81 :
               TTranslator.ReadEnumerationDeclaration(Self);
               break;
            case 87 :
               Result.Functions.push(TTranslator.ReadAmbientFunctionDeclaration(Self));
               break;
            case 89 :
               TTranslator.ReadImportDeclaration(Self);
               break;
            case 132 :
               Result.TypeAliases.push(TTranslator.ReadTypeAliasDeclaration(Self));
               break;
            case 107 :
               Result.Interfaces.push(TTranslator.ReadInterfaceDeclaration(Self));
               TTranslator.ReadToken$2(Self,AmbientNamespaceTokens,true);
               break;
            case 102 :
               Result.Variables.push(TTranslator.ReadAmbientVariableDeclaration(Self));
               break;
         }
         if (TTranslator.a$2(Self)==23) {
            TTranslator.ReadToken$2(Self,AmbientNamespaceTokens,true);
         }
      }
      TTranslator.AssumeToken(Self,16);
      return Result
   }
   ,ReadAmbientPropertyMemberDeclaration:function(Self) {
      var Result = null;
      var MemberName = "";
      TTranslator.AssumeIdentifier(Self,[]);
      MemberName = TTranslator.a$3(Self);
      TTranslator.ReadToken$2(Self,[54, 17, 23].slice(),true);
      if (TTranslator.a$2(Self)==17) {
         Result = TTranslator.ReadAmbientPropertyMemberDeclarationMethod(Self);
      } else {
         Result = TTranslator.ReadAmbientPropertyMemberDeclarationProperty(Self);
      }
      Result.Name = MemberName;
      if (Self.NeedsSemicolon) {
         TTranslator.AssumeIdentifier(Self,[23, 16, 24].slice());
      }
      return Result
   }
   ,ReadAmbientPropertyMemberDeclarationMethod:function(Self) {
      var Result = null;
      TTranslator.AssumeToken(Self,17);
      Result = TCustomDeclaration.Create$10$($New(TAmbientPropertyMemberDeclarationMethod),$AsIntf(Self,"IDeclarationOwner"));
      Result.CallSignature = TTranslator.ReadCallSignature(Self);
      TTranslator.AssumeToken$1(Self,[18, 23, 112, 111, 110].slice());
      return Result
   }
   ,ReadAmbientPropertyMemberDeclarationProperty:function(Self) {
      var Result = null;
      Result = TCustomDeclaration.Create$10$($New(TAmbientPropertyMemberDeclarationProperty),$AsIntf(Self,"IDeclarationOwner"));
      if (TTranslator.a$2(Self)==54) {
         Result.Type = TTranslator.ReadType(Self);
      }
      return Result
   }
   ,ReadAmbientVariableDeclaration:function(Self) {
      var Result = null;
      TTranslator.AssumeToken$1(Self,[102, 108, 74].slice());
      Result = TCustomDeclaration.Create$10$($New(TAmbientVariableDeclaration),$AsIntf(Self,"IDeclarationOwner"));
      Result.IsConst = TTranslator.a$2(Self)==74;
      TTranslator.ReadIdentifier(Self,true);
      TTranslator.ReadAmbientBindingList(Self,Result.AmbientBindingList);
      return Result
   }
   ,ReadCallSignature:function(Self) {
      var Result = null;
      TTranslator.AssumeToken$1(Self,[17, 25].slice());
      Result = TCustomDeclaration.Create$10$($New(TCallSignature),$AsIntf(Self,"IDeclarationOwner"));
      if (TTranslator.a$2(Self)==25) {
         do {
            Result.TypeParameters.push(TTranslator.ReadTypeParameter(Self));
         } while (!(TTranslator.a$2(Self)!=24));
         TTranslator.ReadToken$1(Self,17,true);
      }
      TTranslator.AssumeToken(Self,17);
      TTranslator.ReadIdentifier$1(Self,[112, 110, 111, 22, 18].slice(),true);
      while (TTranslator.a$2(Self)!=18) {
         Result.ParameterList.push(TTranslator.ReadParameter(Self));
         if (TTranslator.a$2(Self)==24) {
            TTranslator.ReadIdentifier$1(Self,[22].slice(),false);
         }
      }
      TTranslator.AssumeToken$1(Self,[18].slice());
      TTranslator.ReadToken$2(Self,[54, 23].slice(),true);
      if (TTranslator.a$2(Self)==54) {
         Result.Type = TTranslator.ReadType(Self);
      }
      return Result
   }
   ,ReadClassDeclaration:function(Self) {
      var Result = null;
      var ClassDeclarationTokens$1 = [],
         ClassDeclarationTokens$1 = [83, 106, 15, 25].slice();
      TTranslator.AssumeToken(Self,73);
      Result = TCustomDeclaration.Create$10$($New(TClassDeclaration),$AsIntf(Self,"IDeclarationOwner"));
      TTranslator.ReadIdentifier(Self,true);
      Result.Name = TTranslator.a$3(Self);
      TTranslator.ReadToken$2(Self,ClassDeclarationTokens$1,true);
      if (TTranslator.a$2(Self)==25) {
         ClassDeclarationTokens$1.push(25);
         do {
            Result.TypeParameters.push(TTranslator.ReadTypeParameter(Self));
         } while (!(TTranslator.a$2(Self)!=24));
         TTranslator.AssumeToken(Self,27);
         TTranslator.ReadToken$2(Self,ClassDeclarationTokens$1,true);
      }
      if (TTranslator.a$2(Self)==83) {
         TTranslator.ReadIdentifier(Self,true);
         Result.Extends.push(TTranslator.ReadTypeReference(Self));
      }
      if (TTranslator.a$2(Self)==106) {
         TTranslator.ReadIdentifier(Self,true);
         Result.Implements.push(TTranslator.ReadTypeReference(Self));
         while (TTranslator.a$2(Self)==24) {
            TTranslator.ReadIdentifier(Self,true);
            Result.Implements.push(TTranslator.ReadTypeReference(Self));
         }
      }
      TTranslator.AssumeToken(Self,15);
      TTranslator.ReadClassMembers(Self,Result);
      return Result
   }
   ,ReadClassMember:function(Self) {
      var Result = null;
      var TypeParameters$6 = [],
         IgnoredKeywords = [],
         IgnoredKeywords = [72, 75, 76, 77, 78, 82, 85, 88, 105].slice();
      var MemberName$1 = "",
         Nullable$1 = false;
      TTranslator.AssumeIdentifier(Self,[92, 9, 19].concat(IgnoredKeywords));
      if (TTranslator.a$2(Self)==19) {
         return TTranslator.ReadIndexMemberDeclaration(Self);
      }
      MemberName$1 = TTranslator.a$3(Self);
      TTranslator.ReadToken$2(Self,[25, 53, 54, 17, 23].slice(),true);
      if (TTranslator.a$2(Self)==25) {
         do {
            TypeParameters$6.push(TTranslator.ReadTypeParameter(Self));
         } while (!(TTranslator.a$2(Self)!=24));
         TTranslator.ReadToken$2(Self,[53, 54, 17, 23].slice(),true);
      }
      Nullable$1 = TTranslator.a$2(Self)==53;
      if (Nullable$1) {
         TTranslator.ReadToken$2(Self,[54, 23].slice(),true);
      }
      switch (TTranslator.a$2(Self)) {
         case 54 :
         case 23 :
            Result = TTranslator.ReadPropertyMemberDeclaration(Self);
            $As(Result,TPropertyMemberDeclaration).Nullable = Nullable$1;
            break;
         case 17 :
            if ((MemberName$1).toLowerCase()=="constructor") {
               Result = TTranslator.ReadConstructorDeclaration(Self);
            } else {
               Result = TTranslator.ReadMethodDeclaration(Self);
            }
            break;
      }
      Result.Name = MemberName$1;
      Result.TypeParameters = TypeParameters$6;
      if (Self.NeedsSemicolon) {
         TTranslator.AssumeToken$1(Self,[23, 24, 16].slice());
      }
      return Result
   }
   ,ReadClassMembers:function(Self, Declaration$1) {
      var ClassElementTokens$1 = [],
         ClassElementTokens$1 = [92, 9, 82, 16, 23, 19].slice();
      var Visibility$4 = 0,
         IsStatic$4 = false,
         Member = null;
      TTranslator.AssumeToken(Self,15);
      TTranslator.ReadIdentifier$1(Self,ClassElementTokens$1,false);
      while (TTranslator.a$2(Self)!=16) {
         Visibility$4 = 0;
         switch (TTranslator.a$2(Self)) {
            case 112 :
               Visibility$4 = 0;
               TTranslator.ReadIdentifier$1(Self,[92].slice(),true);
               break;
            case 111 :
               Visibility$4 = 1;
               TTranslator.ReadIdentifier$1(Self,[92].slice(),true);
               break;
            case 110 :
               Visibility$4 = 2;
               TTranslator.ReadIdentifier$1(Self,[92].slice(),true);
               break;
         }
         IsStatic$4 = TTranslator.a$2(Self)==113;
         if (IsStatic$4) {
            TTranslator.ReadIdentifier$1(Self,[92, 17].slice(),true);
         }
         Member = TTranslator.ReadClassMember(Self);
         Member.Visibility = Visibility$4;
         Member.IsStatic = IsStatic$4;
         Declaration$1.Members.push(Member);
         if (TTranslator.a$2(Self)==23) {
            TTranslator.ReadIdentifier$1(Self,ClassElementTokens$1,false);
         }
      }
   }
   ,ReadConstructorDeclaration:function(Self) {
      var Result = null;
      Result = TCustomDeclaration.Create$10$($New(TConstructorDeclaration),$AsIntf(Self,"IDeclarationOwner"));
      Result.Type = TTranslator.ReadFunctionType(Self);
      if (Self.NeedsSemicolon) {
         TTranslator.AssumeToken$1(Self,[23, 16].slice());
      }
      return Result
   }
   ,ReadConstructorSignature:function(Self) {
      var Result = null;
      TTranslator.AssumeToken(Self,92);
      Result = TCustomDeclaration.Create$10$($New(TConstructorDeclaration),$AsIntf(Self,"IDeclarationOwner"));
      TTranslator.ReadToken$2(Self,[17, 25].slice(),true);
      if (TTranslator.a$2(Self)==25) {
         do {
            Result.TypeParameters.push(TTranslator.ReadTypeParameter(Self));
         } while (!(TTranslator.a$2(Self)!=24));
         TTranslator.ReadToken$2(Self,[17].slice(),true);
      }
      TTranslator.AssumeToken(Self,17);
      TTranslator.ReadIdentifier$1(Self,[112, 110, 111, 22, 18].slice(),true);
      while (TTranslator.a$2(Self)!=18) {
         Result.ParameterList.push(TTranslator.ReadParameter(Self));
         if (TTranslator.a$2(Self)==24) {
            TTranslator.ReadIdentifier$1(Self,[22].slice(),false);
         }
      }
      TTranslator.AssumeToken(Self,18);
      TTranslator.ReadToken$1(Self,54,true);
      Result.Type = TTranslator.ReadTypeAnnotation(Self);
      return Result
   }
   ,ReadConstructorType:function(Self) {
      var Result = null;
      TTranslator.AssumeToken(Self,92);
      Result = TCustomDeclaration.Create$10$($New(TConstructorType),$AsIntf(Self,"IDeclarationOwner"));
      TTranslator.ReadToken$1(Self,17,true);
      while (TTranslator.ReadIdentifier$1(Self,[22].slice(),false)) {
         Result.ParameterList.push(TTranslator.ReadFunctionParameter(Self));
         TTranslator.AssumeToken$1(Self,[24, 18, 23].slice());
         if (TTranslator.a$2(Self)==18) {
            break;
         }
      }
      TTranslator.AssumeToken$1(Self,[18, 23].slice());
      if (TTranslator.ReadToken$2(Self,[54, 34].slice(),false)) {
         Result.ResultType = TTranslator.ReadType(Self);
      }
      return Result
   }
   ,ReadDefinition:function(Self) {
      var DefinitionTokens = [],
         DefinitionTokens = [82, 122, 107, 125, 89, 1].slice();
      var IsExport$3 = false,
         ExportTokens = [],
         Interface$1 = null;
      TTranslator.ReadToken$2(Self,DefinitionTokens,true);
      while (TTranslator.a$2(Self)!=1) {
         IsExport$3 = TTranslator.a$2(Self)==82;
         if (IsExport$3) {
            ExportTokens = DefinitionTokens;
            ExportTokens.push(82);
            TTranslator.ReadToken$2(Self,ExportTokens,true);
         }
         switch (TTranslator.a$2(Self)) {
            case 122 :
               Self.FDeclarations.push(TTranslator.ReadAmbientDeclaration(Self));
               break;
            case 107 :
               Interface$1 = TTranslator.ReadInterfaceDeclaration(Self);
               Interface$1.IsExport = IsExport$3;
               Self.FInterfaces.push(Interface$1);
               TTranslator.AssumeToken(Self,16);
               TTranslator.ReadToken$2(Self,DefinitionTokens,true);
               break;
            case 125 :
               Self.FModules.push(TTranslator.ReadModuleDeclaration(Self));
               break;
            case 89 :
               Self.FImports.push(TTranslator.ReadImportDeclaration(Self));
               break;
         }
         if (([16,23].indexOf(TTranslator.a$2(Self))>=0)) {
            TTranslator.ReadToken$2(Self,DefinitionTokens,true);
         }
      }
   }
   ,ReadEnumerationDeclaration:function(Self) {
      var Result = null;
      var IgnoreKeywords = [],
         IgnoreKeywords = [81, 77, 78, 89, 96].slice();
      TTranslator.AssumeToken(Self,81);
      Result = TCustomDeclaration.Create$10$($New(TEnumerationDeclaration),$AsIntf(Self,"IDeclarationOwner"));
      TTranslator.ReadIdentifier(Self,true);
      Result.Name = TTranslator.a$3(Self);
      TTranslator.ReadToken$1(Self,15,true);
      TTranslator.ReadIdentifier$1(Self,[16].concat(IgnoreKeywords),true);
      if (TTranslator.a$2(Self)!=16) {
         do {
            Result.Items.push(TTranslator.ReadEnumerationItem(Self));
            if (TTranslator.a$2(Self)==16) {
               break;
            }
         } while (!(!TTranslator.ReadIdentifier$1(Self,IgnoreKeywords,false)));
      }
      TTranslator.AssumeToken(Self,16);
      return Result
   }
   ,ReadEnumerationItem:function(Self) {
      var Result = null;
      var IgnoreKeywords$1 = [],
         IgnoreKeywords$1 = [81, 77, 78, 89, 96].slice();
      TTranslator.AssumeIdentifier(Self,IgnoreKeywords$1);
      Result = TCustomDeclaration.Create$10$($New(TEnumerationItem),$AsIntf(Self,"IDeclarationOwner"));
      Result.Name = TTranslator.a$3(Self);
      if (TTranslator.ReadToken$1(Self,56,false)) {
         TTranslator.ReadToken$1(Self,8,true);
         Result.Value = TTranslator.a$3(Self);
         TTranslator.ReadToken(Self);
      }
      TTranslator.AssumeToken$1(Self,[24, 16].slice());
      return Result
   }
   ,ReadExportDeclaration:function(Self) {
      var Result = null;
      TTranslator.AssumeToken(Self,82);
      Result = TCustomDeclaration.Create$10$($New(TExportDeclaration),$AsIntf(Self,"IDeclarationOwner"));
      TTranslator.ReadIdentifier$1(Self,[77].slice(),true);
      Result.FDefault = TTranslator.a$2(Self)==82||(TTranslator.a$3(Self)).toLowerCase()=="default";
      if (Result.FDefault) {
         TTranslator.ReadIdentifier(Self,true);
      }
      Result.Name = TTranslator.a$3(Self);
      TTranslator.ReadToken$1(Self,23,true);
      return Result
   }
   ,ReadFunctionDeclaration:function(Self) {
      var Result = null;
      TTranslator.AssumeToken(Self,87);
      Result = TCustomDeclaration.Create$10$($New(TFunctionDeclaration),$AsIntf(Self,"IDeclarationOwner"));
      TTranslator.ReadIdentifier(Self,true);
      Result.Name = TTranslator.a$3(Self);
      TTranslator.ReadToken$2(Self,[17].slice(),true);
      Result.Type = TTranslator.ReadFunctionType(Self);
      return Result
   }
   ,ReadFunctionParameter:function(Self) {
      var Result = null;
      var OpenArray = false;
      var ParameterTokens = [],
         ParameterTokens = [53, 24, 54, 18].slice();
      TTranslator.AssumeIdentifier(Self,[22].slice());
      OpenArray = TTranslator.a$2(Self)==22;
      if (OpenArray) {
         TTranslator.ReadIdentifier(Self,true);
      }
      Result = TCustomDeclaration.Create$10$($New(TFunctionParameter),$AsIntf(Self,"IDeclarationOwner"));
      Result.Name = TTranslator.a$3(Self);
      TTranslator.ReadToken$2(Self,ParameterTokens,true);
      Result.IsOptional = TTranslator.a$2(Self)==53;
      ParameterTokens.push(53);
      if (Result.IsOptional) {
         TTranslator.ReadToken$2(Self,ParameterTokens,true);
      }
      if (TTranslator.a$2(Self)==54) {
         Result.Type = TTranslator.ReadType(Self);
      }
      return Result
   }
   ,ReadFunctionType:function(Self) {
      var Result = null;
      TTranslator.AssumeToken$1(Self,[17, 25].slice());
      Result = TCustomDeclaration.Create$10$($New(TFunctionType),$AsIntf(Self,"IDeclarationOwner"));
      if (TTranslator.a$2(Self)==25) {
         do {
            Result.TypeParameters.push(TTranslator.ReadTypeParameter(Self));
         } while (!(TTranslator.a$2(Self)!=24));
         TTranslator.ReadToken$1(Self,17,true);
      }
      while (TTranslator.ReadIdentifier$1(Self,[22].slice(),false)) {
         Result.ParameterList.push(TTranslator.ReadFunctionParameter(Self));
         TTranslator.AssumeToken$1(Self,[24, 18, 23].slice());
         if (TTranslator.a$2(Self)==18) {
            break;
         }
      }
      TTranslator.AssumeToken$1(Self,[18, 23].slice());
      if (TTranslator.ReadToken$2(Self,[54, 34].slice(),false)) {
         Result.ResultType = TTranslator.ReadType(Self);
      }
      return Result
   }
   ,ReadIdentifier$1:function(Self, AdditionalToken$1, Required) {
      var Result = false;
      TTranslator.ReadToken(Self);
      Result = Self.FScanner.isIdentifier()||AdditionalToken$1.indexOf(TTranslator.a$2(Self))>=0;
      if ((!Result)&&Required) {
         TTranslator.HandleScanError(Self,0);
      }
      return Result
   }
   ,ReadIdentifier:function(Self, Required$1) {
      var Result = false;
      TTranslator.ReadToken(Self);
      Result = Self.FScanner.isIdentifier();
      if ((!Result)&&Required$1) {
         TTranslator.HandleScanError(Self,69);
      }
      return Result
   }
   ,ReadIdentifierPath:function(Self) {
      var Result = "";
      TTranslator.AssumeIdentifier(Self,[9, 97].slice());
      Result = TTranslator.a$3(Self);
      while (TTranslator.ReadToken$1(Self,21,false)) {
         TTranslator.ReadIdentifier(Self,true);
         Result+="."+TTranslator.a$3(Self);
      }
      return Result
   }
   ,ReadImportDeclaration:function(Self) {
      var Result = null;
      TTranslator.AssumeToken(Self,89);
      Result = TCustomDeclaration.Create$10$($New(TImportDeclaration),$AsIntf(Self,"IDeclarationOwner"));
      TTranslator.ReadIdentifier$1(Self,[37, 9].slice(),true);
      switch (TTranslator.a$2(Self)) {
         case 37 :
            Result.Name = "*";
            TTranslator.ReadToken$1(Self,116,true);
            TTranslator.ReadIdentifier(Self,true);
            TTranslator.ReadToken$1(Self,133,true);
            TTranslator.ReadToken$1(Self,9,true);
            break;
         case 9 :
            Result.Name = Self.FScanner.getTokenValue();
            break;
         default :
            Result.Name = TTranslator.a$3(Self);
            TTranslator.ReadToken$1(Self,56,true);
            TTranslator.ReadIdentifier$1(Self,[127].slice(),true);
            if (TTranslator.a$2(Self)==127) {
               TTranslator.ReadToken$1(Self,17,false);
               TTranslator.ReadToken$1(Self,9,false);
               TTranslator.ReadToken$1(Self,18,false);
            } else {
               Result.Value = TTranslator.ReadIdentifierPath(Self);
            }
      }
      if (Self.NeedsSemicolon) {
         TTranslator.ReadToken$1(Self,23,true);
      }
      return Result
   }
   ,ReadIndexMemberDeclaration:function(Self) {
      var Result = null;
      TTranslator.AssumeToken(Self,19);
      Result = TCustomDeclaration.Create$10$($New(TIndexMemberDeclaration),$AsIntf(Self,"IDeclarationOwner"));
      Result.IndexSignature = TTranslator.ReadIndexSignature(Self);
      if (Self.NeedsSemicolon) {
         TTranslator.AssumeIdentifier(Self,[23, 16, 24].slice());
      }
      return Result
   }
   ,ReadIndexSignature:function(Self) {
      var Result = null;
      TTranslator.AssumeToken(Self,19);
      Result = TCustomDeclaration.Create$10$($New(TIndexSignature),$AsIntf(Self,"IDeclarationOwner"));
      TTranslator.ReadIdentifier(Self,true);
      Result.Name = TTranslator.a$3(Self);
      TTranslator.ReadToken$1(Self,54,true);
      TTranslator.ReadToken$2(Self,[130, 128].slice(),true);
      Result.IsStringIndex = TTranslator.a$2(Self)==130;
      TTranslator.ReadToken$1(Self,20,true);
      TTranslator.ReadToken$1(Self,54,true);
      Result.Type = TTranslator.ReadTypeAnnotation(Self);
      return Result
   }
   ,ReadInterfaceDeclaration:function(Self) {
      var Result = null;
      TTranslator.AssumeToken(Self,107);
      Result = TCustomDeclaration.Create$10$($New(TInterfaceDeclaration),$AsIntf(Self,"IDeclarationOwner"));
      TTranslator.ReadIdentifier(Self,true);
      Result.Name = TTranslator.a$3(Self);
      TTranslator.ReadToken$2(Self,[25, 83, 15].slice(),true);
      if (TTranslator.a$2(Self)==25) {
         do {
            Result.TypeParameters.push(TTranslator.ReadTypeParameter(Self));
         } while (!(TTranslator.a$2(Self)!=24));
         TTranslator.ReadToken$2(Self,[83, 15].slice(),true);
      }
      if (TTranslator.a$2(Self)==83) {
         TTranslator.ReadIdentifier(Self,true);
         Result.Extends.push(TTranslator.ReadTypeReference(Self));
         while (TTranslator.a$2(Self)==24) {
            TTranslator.ReadIdentifier(Self,true);
            Result.Extends.push(TTranslator.ReadTypeReference(Self));
         }
      }
      TTranslator.AssumeToken(Self,15);
      Result.Type = TTranslator.ReadObjectType(Self);
      TTranslator.AssumeToken(Self,16);
      return Result
   }
   ,ReadMethodDeclaration:function(Self) {
      var Result = null;
      Result = TCustomDeclaration.Create$10$($New(TMethodDeclaration),$AsIntf(Self,"IDeclarationOwner"));
      Result.CallSignature = TTranslator.ReadCallSignature(Self);
      if (Self.NeedsSemicolon) {
         TTranslator.AssumeToken$1(Self,[23, 16].slice());
      }
      return Result
   }
   ,ReadModuleDeclaration:function(Self) {
      var Result = null;
      var ModuleTokens$1 = [],
         ModuleTokens$1 = [73, 82, 81, 89, 125, 87, 107, 102, 23, 16].slice();
      TTranslator.AssumeToken(Self,125);
      Result = TCustomDeclaration.Create$10$($New(TModuleDeclaration),$AsIntf(Self,"IDeclarationOwner"));
      TTranslator.ReadIdentifier$1(Self,[9].slice(),true);
      Result.Name = TTranslator.ReadIdentifierPath(Self);
      TTranslator.AssumeToken(Self,15);
      TTranslator.ReadToken$2(Self,ModuleTokens$1,true);
      while (TTranslator.a$2(Self)!=16) {
         switch (TTranslator.a$2(Self)) {
            case 73 :
               Result.Classes.push(TTranslator.ReadClassDeclaration(Self));
               break;
            case 82 :
               Result.Exports.push(TTranslator.ReadExportDeclaration(Self));
               break;
            case 81 :
               TTranslator.ReadEnumerationDeclaration(Self);
               break;
            case 87 :
               Result.Functions.push(TTranslator.ReadFunctionDeclaration(Self));
               break;
            case 89 :
               TTranslator.ReadImportDeclaration(Self);
               break;
            case 125 :
               Result.Modules.push(TTranslator.ReadModuleDeclaration(Self));
               break;
            case 107 :
               Result.Interfaces.push(TTranslator.ReadInterfaceDeclaration(Self));
               break;
            case 102 :
               Result.Variables.push(TTranslator.ReadVariableDeclaration(Self));
               break;
         }
         TTranslator.ReadToken$2(Self,ModuleTokens$1,true);
      }
      TTranslator.AssumeToken(Self,16);
      return Result
   }
   ,ReadNamespaceDeclaration:function(Self) {
      var Result = null;
      var NamespaceTokens = [],
         NamespaceTokens = [115, 73, 122, 82, 81, 89, 87, 107, 23, 16].slice();
      var IsAbstract$1 = false,
         ClassDeclaration = null;
      TTranslator.AssumeToken(Self,126);
      TTranslator.ReadIdentifier$1(Self,[9].slice(),true);
      Result = TCustomDeclaration.Create$10$($New(TNamespaceDeclaration),$AsIntf(Self,"IDeclarationOwner"));
      Result.Name = TTranslator.ReadIdentifierPath(Self);
      TTranslator.AssumeToken(Self,15);
      TTranslator.ReadToken$2(Self,NamespaceTokens,true);
      while (TTranslator.a$2(Self)!=16) {
         IsAbstract$1 = TTranslator.a$2(Self)==115;
         if (IsAbstract$1) {
            TTranslator.ReadToken$2(Self,[73].slice(),true);
         }
         switch (TTranslator.a$2(Self)) {
            case 73 :
               ClassDeclaration = TTranslator.ReadClassDeclaration(Self);
               ClassDeclaration.IsAbstract = IsAbstract$1;
               Result.Classes.push(ClassDeclaration);
               break;
            case 81 :
               TTranslator.ReadEnumerationDeclaration(Self);
               break;
            case 87 :
               Result.Functions.push(TTranslator.ReadFunctionDeclaration(Self));
               break;
            case 89 :
               TTranslator.ReadImportDeclaration(Self);
               break;
            case 107 :
               Result.Interfaces.push(TTranslator.ReadInterfaceDeclaration(Self));
               break;
         }
         TTranslator.ReadToken$2(Self,NamespaceTokens,true);
      }
      TTranslator.AssumeToken(Self,16);
      return Result
   }
   ,ReadObjectType:function(Self) {
      var Result = null;
      var ObjectTokens = [],
         ObjectTokens = [9, 8, 92, 25, 17, 19, 16].slice();
      var IgnoredKeywords$1 = [],
         IgnoredKeywords$1 = [72, 73, 75, 76, 77, 78, 82, 83, 85, 86, 89, 90, 94, 97, 98, 100].slice();
      TTranslator.AssumeToken(Self,15);
      Result = TCustomDeclaration.Create$10$($New(TObjectType),$AsIntf(Self,"IDeclarationOwner"));
      TTranslator.ReadIdentifier$1(Self,ObjectTokens.concat(IgnoredKeywords$1),true);
      while (TTranslator.a$2(Self)!=16) {
         Result.Members.push(TTranslator.ReadTypeMember(Self));
         if (([23,24].indexOf(TTranslator.a$2(Self))>=0)) {
            TTranslator.ReadIdentifier$1(Self,ObjectTokens.concat(IgnoredKeywords$1),true);
         }
      }
      TTranslator.AssumeToken(Self,16);
      return Result
   }
   ,ReadParameter:function(Self) {
      var Result = null;
      TTranslator.AssumeIdentifier(Self,[112, 110, 111, 22].slice());
      Result = TCustomDeclaration.Create$10$($New(TParameter),$AsIntf(Self,"IDeclarationOwner"));
      Result.Name = TTranslator.a$3(Self);
      Result.IsRest = TTranslator.a$2(Self)==22;
      if (Result.IsRest) {
         TTranslator.ReadIdentifier(Self,true);
         Result.Name = TTranslator.a$3(Self);
         if (TTranslator.ReadToken$1(Self,54,false)) {
            Result.Type = TTranslator.ReadTypeAnnotation(Self);
         }
         TTranslator.AssumeToken(Self,18);
         return Result;
      }
      TTranslator.AssumeIdentifier(Self,[112, 110, 111].slice());
      switch (TTranslator.a$2(Self)) {
         case 112 :
            Result.AccessibilityModifier = 0;
            TTranslator.ReadIdentifier(Self,false);
            break;
         case 110 :
            Result.AccessibilityModifier = 1;
            TTranslator.ReadIdentifier(Self,false);
            break;
         case 111 :
            Result.AccessibilityModifier = 2;
            TTranslator.ReadIdentifier(Self,false);
            break;
      }
      TTranslator.AssumeIdentifier(Self,[]);
      TTranslator.ReadToken$2(Self,[53, 54, 56, 24, 18].slice(),true);
      Result.IsOptional = TTranslator.a$2(Self)==53;
      if (Result.IsOptional) {
         TTranslator.ReadToken$2(Self,[54, 56, 24, 18].slice(),true);
      }
      if (TTranslator.a$2(Self)==54) {
         Result.Type = TTranslator.ReadType(Self);
      }
      TTranslator.AssumeToken$1(Self,[56, 24, 18].slice());
      if (TTranslator.a$2(Self)==56) {
         TTranslator.ReadIdentifier(Self,true);
         Result.DefaultValue = TTranslator.a$3(Self);
      }
      TTranslator.AssumeToken$1(Self,[24, 18].slice());
      return Result
   }
   ,ReadPrimaryType:function(Self) {
      var Result = null;
      var PrimaryTypeTokens = [],
         PrimaryTypeTokens = [69, 9, 117, 128, 130, 120, 103, 101, 97, 15, 17, 19].slice();
      var OldType = null;
      TTranslator.AssumeToken$1(Self,PrimaryTypeTokens);
      switch (TTranslator.a$2(Self)) {
         case 17 :
            Result = TTranslator.ReadType(Self);
            TTranslator.AssumeToken(Self,18);
            TTranslator.ReadToken(Self);
            break;
         case 69 :
         case 97 :
            Result = TNamedType.Create$12($New(TNamedType),$AsIntf(Self,"IDeclarationOwner"),TTranslator.ReadIdentifierPath(Self));
            if (TTranslator.a$2(Self)==25) {
               do {
                  $As(Result,TNamedType).Arguments.push(TTranslator.ReadTypeArgument(Self));
               } while (!(TTranslator.a$2(Self)!=24));
               TTranslator.AssumeToken(Self,27);
               TTranslator.ReadToken(Self);
            }
            break;
         case 9 :
            Result = TNamedType.Create$12($New(TNamedType),$AsIntf(Self,"IDeclarationOwner"),Self.FScanner.getTokenValue());
            TTranslator.ReadToken(Self);
            break;
         case 117 :
            Result = TCustomDeclaration.Create$10$($New(TVariantType),$AsIntf(Self,"IDeclarationOwner"));
            TTranslator.ReadToken(Self);
            break;
         case 128 :
            Result = TCustomDeclaration.Create$10$($New(TFloatType),$AsIntf(Self,"IDeclarationOwner"));
            TTranslator.ReadToken(Self);
            break;
         case 103 :
            Result = null;
            TTranslator.ReadToken(Self);
            break;
         case 101 :
            Result = TCustomDeclaration.Create$10$($New(TTypeOfType),$AsIntf(Self,"IDeclarationOwner"));
            $As(Result,TTypeOfType).Type = TTranslator.ReadType(Self);
            break;
         case 130 :
            Result = TCustomDeclaration.Create$10$($New(TStringType),$AsIntf(Self,"IDeclarationOwner"));
            TTranslator.ReadToken(Self);
            break;
         case 120 :
            Result = TCustomDeclaration.Create$10$($New(TBooleanType),$AsIntf(Self,"IDeclarationOwner"));
            TTranslator.ReadToken(Self);
            break;
         case 15 :
            Result = TTranslator.ReadObjectType(Self);
            TTranslator.ReadToken(Self);
            break;
         case 19 :
            Result = TTranslator.ReadTupleType(Self);
            TTranslator.ReadToken(Self);
            break;
      }
      while (TTranslator.a$2(Self)==19) {
         OldType = Result;
         Result = TCustomDeclaration.Create$10$($New(TArrayType),$AsIntf(Self,"IDeclarationOwner"));
         $As(Result,TArrayType).Type = OldType;
         TTranslator.ReadToken$1(Self,20,true);
         TTranslator.ReadToken(Self);
      }
      return Result
   }
   ,ReadPropertyMemberDeclaration:function(Self) {
      var Result = null;
      TTranslator.AssumeToken$1(Self,[54, 23].slice());
      Result = TCustomDeclaration.Create$10$($New(TPropertyMemberDeclaration),$AsIntf(Self,"IDeclarationOwner"));
      if (TTranslator.a$2(Self)==23) {
         return Result;
      }
      Result.Type = TTranslator.ReadType(Self);
      if (Self.NeedsSemicolon) {
         TTranslator.AssumeIdentifier(Self,[23, 16, 24].slice());
      }
      return Result
   }
   ,ReadToken$2:function(Self, Tokens$1, Required$2) {
      var Result = false;
      Result = Tokens$1.indexOf(TTranslator.ReadToken(Self))>=0;
      if ((!Result)&&Required$2) {
         TTranslator.HandleScanError(Self,0);
      }
      return Result
   }
   ,ReadToken$1:function(Self, Token$1, Required$3) {
      var Result = false;
      Result = TTranslator.ReadToken(Self)==Token$1;
      if ((!Result)&&Required$3) {
         TTranslator.HandleScanError(Self,Token$1);
      }
      return Result
   }
   ,ReadToken:function(Self) {
      var Result = 0;
      Result = Self.FScanner.scan();
      return Result
   }
   ,ReadTupleType:function(Self) {
      var Result = null;
      TTranslator.AssumeToken(Self,19);
      Result = TCustomDeclaration.Create$10$($New(TTupleType),$AsIntf(Self,"IDeclarationOwner"));
      do {
         Result.Types.push(TTranslator.ReadType(Self));
      } while (!(TTranslator.a$2(Self)==20));
      TTranslator.AssumeToken(Self,20);
      return Result
   }
   ,ReadType:function(Self) {
      var Result = null;
      var TypeTokens = [],
         TypeTokens = [69, 9, 117, 128, 130, 120, 103, 101, 97, 92, 25, 15, 17, 19].slice();
      var TextPos$1 = 0,
         IsFunctionType = false,
         OldType$1 = null;
      TextPos$1 = Self.FScanner.getTextPos();
      TTranslator.ReadToken$2(Self,TypeTokens,true);
      if (TTranslator.a$2(Self)==17) {
         IsFunctionType = true;
         TTranslator.ReadIdentifier$1(Self,TypeTokens.concat([112, 111, 110, 18, 22]),true);
         if (!([112,111,110,18,22].indexOf(TTranslator.a$2(Self))>=0)) {
            if (Self.FScanner.isIdentifier()) {
               TTranslator.ReadToken$2(Self,[25, 47, 54, 24, 53, 21, 19, 18].slice(),true);
               IsFunctionType = ([54,53,24,18].indexOf(TTranslator.a$2(Self))>=0);
            } else {
               IsFunctionType = !TTranslator.a$2(Self)==17;
            }
         }
         Self.FScanner.setTextPos(TextPos$1);
         TTranslator.ReadToken$2(Self,TypeTokens,true);
         if (IsFunctionType) {
            return TTranslator.ReadFunctionType(Self);
         }
      }
      if (TTranslator.a$2(Self)==25) {
         return TTranslator.ReadFunctionType(Self);
      }
      if (TTranslator.a$2(Self)==92) {
         return TTranslator.ReadConstructorType(Self);
      }
      Result = TTranslator.ReadPrimaryType(Self);
      while (TTranslator.a$2(Self)==47) {
         if (!$Is(Result,TUnionType)) {
            OldType$1 = Result;
            Result = TCustomDeclaration.Create$10$($New(TUnionType),$AsIntf(Self,"IDeclarationOwner"));
            $As(Result,TUnionType).Types.push(OldType$1);
         }
         TTranslator.ReadToken$2(Self,TypeTokens,true);
         $As(Result,TUnionType).Types.push(TTranslator.ReadPrimaryType(Self));
      }
      return Result
   }
   ,ReadTypeAliasDeclaration:function(Self) {
      var Result = null;
      TTranslator.AssumeToken(Self,132);
      Result = TCustomDeclaration.Create$10$($New(TTypeAlias),$AsIntf(Self,"IDeclarationOwner"));
      TTranslator.ReadIdentifier(Self,true);
      Result.Name = TTranslator.a$3(Self);
      TTranslator.ReadToken$2(Self,[25, 56].slice(),true);
      if (TTranslator.a$2(Self)==25) {
         Result.TypeParameters.push(TTranslator.ReadTypeParameter(Self));
         TTranslator.ReadToken$1(Self,56,true);
      }
      Result.Type = TTranslator.ReadType(Self);
      if (Self.NeedsSemicolon) {
         TTranslator.AssumeToken(Self,23);
      }
      return Result
   }
   ,ReadTypeAnnotation:function(Self) {
      var Result = null;
      TTranslator.AssumeToken(Self,54);
      Result = TTranslator.ReadType(Self);
      return Result
   }
   ,ReadTypeArgument:function(Self) {
      var Result = null;
      TTranslator.AssumeToken$1(Self,[25, 24].slice());
      Result = TCustomDeclaration.Create$10$($New(TTypeArgument),$AsIntf(Self,"IDeclarationOwner"));
      Result.Type = TTranslator.ReadType(Self);
      TTranslator.AssumeToken$1(Self,[27, 24].slice());
      return Result
   }
   ,ReadTypeMember:function(Self) {
      var Result = null;
      var TypeArguments$1 = [],
         TypeTokens$1 = [],
         TypeTokens$1 = [9, 8, 110, 92, 25, 17, 19].slice();
      var IgnoredKeywords$2 = [],
         IgnoredKeywords$2 = [72, 73, 75, 76, 77, 78, 82, 83, 85, 86, 89, 90, 94, 97, 98, 100].slice();
      var TextPos$2 = 0,
         IsConstructorType = false,
         MemberName$2 = "",
         Nullable$2 = false;
      TextPos$2 = Self.FScanner.getTextPos();
      TTranslator.AssumeIdentifier(Self,TypeTokens$1.concat(IgnoredKeywords$2));
      if (TTranslator.a$2(Self)==92) {
         IsConstructorType = !TTranslator.ReadToken$2(Self,[53, 54].slice(),false);
         Self.FScanner.setTextPos(TextPos$2-3);
         Self.FScanner.scan();
         if (IsConstructorType) {
            return TTranslator.ReadConstructorSignature(Self);
         }
      }
      if (([17,25].indexOf(TTranslator.a$2(Self))>=0)) {
         return TTranslator.ReadCallSignature(Self);
      }
      if (TTranslator.a$2(Self)==19) {
         return TTranslator.ReadIndexSignature(Self);
      }
      if (Self.FScanner.isIdentifier()||[9, 8, 92].concat(IgnoredKeywords$2).indexOf(Self.FScanner.getToken())>=0) {
         MemberName$2 = TTranslator.a$3(Self);
         TTranslator.ReadToken$2(Self,[25, 53, 54, 17].slice(),true);
         Nullable$2 = TTranslator.a$2(Self)==53;
         if (Nullable$2) {
            TTranslator.ReadToken$2(Self,[54, 17, 25].slice(),true);
         }
         switch (TTranslator.a$2(Self)) {
            case 54 :
               Result = TTranslator.ReadPropertyMemberDeclaration(Self);
               $As(Result,TPropertyMemberDeclaration).Nullable = Nullable$2;
               break;
            case 17 :
            case 25 :
               Result = TTranslator.ReadMethodDeclaration(Self);
               break;
         }
         Result.TypeArguments = TypeArguments$1;
         Result.Name = MemberName$2;
      }
      return Result
   }
   ,ReadTypeParameter:function(Self) {
      var Result = null;
      TTranslator.AssumeToken$1(Self,[25, 24].slice());
      Result = TCustomDeclaration.Create$10$($New(TTypeParameter),$AsIntf(Self,"IDeclarationOwner"));
      TTranslator.ReadIdentifier(Self,true);
      Result.Name = TTranslator.a$3(Self);
      TTranslator.ReadToken$2(Self,[83, 27, 24].slice(),true);
      if (TTranslator.a$2(Self)==83) {
         Result.ExtendsType = TTranslator.ReadType(Self);
         TTranslator.AssumeToken$1(Self,[27, 24].slice());
      }
      return Result
   }
   ,ReadTypeReference:function(Self) {
      var Result = null;
      TTranslator.AssumeIdentifier(Self,[]);
      Result = TCustomDeclaration.Create$10$($New(TTypeReference),$AsIntf(Self,"IDeclarationOwner"));
      Result.Name = TTranslator.ReadIdentifierPath(Self);
      if (TTranslator.a$2(Self)==25) {
         do {
            Result.Arguments.push(TTranslator.ReadTypeArgument(Self));
         } while (!(TTranslator.a$2(Self)!=24));
         TTranslator.ReadToken(Self);
      }
      return Result
   }
   ,ReadVariableDeclaration:function(Self) {
      var Result = null;
      TTranslator.AssumeToken(Self,102);
      Result = TCustomDeclaration.Create$10$($New(TVariableDeclaration),$AsIntf(Self,"IDeclarationOwner"));
      TTranslator.ReadIdentifier(Self,true);
      Result.Name = TTranslator.a$3(Self);
      TTranslator.ReadToken$1(Self,54,true);
      Result.Type = TTranslator.ReadType(Self);
      return Result
   }
   ,Translate:function(Self, Source) {
      var Result = "";
      Self.FScanner = TypeScriptExport.createScanner(0,true,0,Source);
      Self.FSourceFile = TypeScriptExport.createSourceFile("main",Source,0);
      try {
         TTranslator.ReadDefinition$(Self);
      } catch ($e) {
         var e = $W($e);
         console.error(e.FMessage);
      }
      Result = TTranslator.BuildPascalHeader$(Self);
      return Result
   }
   ,Destroy:TObject.Destroy
   ,BuildPascalHeader$:function($){return $.ClassType.BuildPascalHeader($)}
   ,ReadDefinition$:function($){return $.ClassType.ReadDefinition($)}
};
TTranslator.$Intf={
   IDeclarationOwner:[]
}
function GetUnitName(FileName) {
   var Result = "";
   var Items$2 = [];
   if (FileName.length==0) {
      return "Unknown";
   }
   Items$2 = (FileName).split("\\");
   Result = Items$2[(Items$2.length-1)];
   Items$2 = (FileName).split("\/");
   Result = Items$2[(Items$2.length-1)];
   Result = StrReplace(Result,"-","_");
   Result = $StrSet(Result,1,(Result.charAt(0)).toUpperCase());
   return Result
};
var TVisibility = [ "vPublic", "vProtected", "vPrivate" ];
var TCustomDeclaration = {
   $ClassName:"TCustomDeclaration",$Parent:TObject
   ,$Init:function ($) {
      TObject.$Init($);
      $.FOwner = null;
   }
   ,BeginIndention:function(Self) {
      ++FIndentionLevel;
   }
   ,BeginNamespace:function(Self, Value$2) {
      FNamespaces.push(Value$2);
   }
   ,Create$10:function(Self, Owner) {
      Self.FOwner = Owner;
      return Self
   }
   ,EndIndention:function(Self) {
      --FIndentionLevel;
   }
   ,EndNamespace:function(Self) {
      FNamespaces.pop();
   }
   ,GetIndentionString:function(Self) {
      var Result = "";
      Result = DupeString("  ",FIndentionLevel);
      return Result
   }
   ,GetNamespaceString:function(Self) {
      var Result = "";
      var Index = 0;
      Result = "";
      if (FNamespaces.length>0) {
         Result+=FNamespaces[0];
         var $temp6;
         for(Index=0+1,$temp6=FNamespaces.length;Index<$temp6;Index++) {
            Result+="."+FNamespaces[Index];
         }
      }
      return Result
   }
   ,Destroy:TObject.Destroy
   ,Create$10$:function($){return $.ClassType.Create$10.apply($.ClassType, arguments)}
   ,GetAsCode$:function($){return $.ClassType.GetAsCode($)}
};
var TCustomType = {
   $ClassName:"TCustomType",$Parent:TCustomDeclaration
   ,$Init:function ($) {
      TCustomDeclaration.$Init($);
   }
   ,Destroy:TObject.Destroy
   ,Create$10:TCustomDeclaration.Create$10
   ,GetAsCode:TCustomDeclaration.GetAsCode
};
var TCustomNamedType = {
   $ClassName:"TCustomNamedType",$Parent:TCustomType
   ,$Init:function ($) {
      TCustomType.$Init($);
   }
   ,GetAsCode:function(Self) {
      var Result = "";
      Result = "J"+TCustomNamedType.GetName$(Self);
      return Result
   }
   ,Destroy:TObject.Destroy
   ,Create$10:TCustomDeclaration.Create$10
   ,GetAsCode$:function($){return $.ClassType.GetAsCode($)}
   ,GetName$:function($){return $.ClassType.GetName($)}
};
var TPredefinedType = {
   $ClassName:"TPredefinedType",$Parent:TCustomNamedType
   ,$Init:function ($) {
      TCustomNamedType.$Init($);
   }
   ,GetAsCode:function(Self) {
      var Result = "";
      Result = TCustomNamedType.GetName$(Self);
      return Result
   }
   ,Destroy:TObject.Destroy
   ,Create$10:TCustomDeclaration.Create$10
   ,GetAsCode$:function($){return $.ClassType.GetAsCode($)}
   ,GetName:TCustomNamedType.GetName
};
var TVariantType = {
   $ClassName:"TVariantType",$Parent:TPredefinedType
   ,$Init:function ($) {
      TPredefinedType.$Init($);
   }
   ,GetName:function(Self) {
      var Result = "";
      Result = "Variant";
      return Result
   }
   ,Destroy:TObject.Destroy
   ,Create$10:TCustomDeclaration.Create$10
   ,GetAsCode:TPredefinedType.GetAsCode
   ,GetName$:function($){return $.ClassType.GetName($)}
};
var TNamedDeclaration = {
   $ClassName:"TNamedDeclaration",$Parent:TCustomDeclaration
   ,$Init:function ($) {
      TCustomDeclaration.$Init($);
      $.Name = "";
   }
   ,Destroy:TObject.Destroy
   ,Create$10:TCustomDeclaration.Create$10
   ,GetAsCode:TCustomDeclaration.GetAsCode
};
var TVariableDeclaration = {
   $ClassName:"TVariableDeclaration",$Parent:TNamedDeclaration
   ,$Init:function ($) {
      TNamedDeclaration.$Init($);
      $.Type = null;
   }
   ,GetAsCode:function(Self) {
      var Result = "";
      console.log("not implemented: TVariableDeclaration.GetAsCode");
      return Result
   }
   ,Destroy:TObject.Destroy
   ,Create$10:TCustomDeclaration.Create$10
   ,GetAsCode$:function($){return $.ClassType.GetAsCode($)}
};
var TUnionType = {
   $ClassName:"TUnionType",$Parent:TCustomType
   ,$Init:function ($) {
      TCustomType.$Init($);
      $.Types = [];
   }
   ,GetAsCode:function(Self) {
      var Result = "";
      var Index$1 = 0;
      var LastType = null;
      Result = "Variant {";
      var $temp7;
      for(Index$1=0,$temp7=(Self.Types.length-1);Index$1<$temp7;Index$1++) {
         Result+=(Self.Types[Index$1])?TCustomDeclaration.GetAsCode$(Self.Types[Index$1]):"void";
         Result+=" or ";
      }
      LastType = Self.Types[(Self.Types.length-1)];
      Result+=(LastType)?TCustomDeclaration.GetAsCode$(LastType):"void";
      Result+="}";
      return Result
   }
   ,Destroy:TObject.Destroy
   ,Create$10:TCustomDeclaration.Create$10
   ,GetAsCode$:function($){return $.ClassType.GetAsCode($)}
};
var TTypeReference = {
   $ClassName:"TTypeReference",$Parent:TCustomDeclaration
   ,$Init:function ($) {
      TCustomDeclaration.$Init($);
      $.Name = "";
      $.Arguments = [];
   }
   ,GetAsCode:function(Self) {
      var Result = "";
      var Index$2 = 0;
      Result = "J"+Self.Name;
      if (Self.Arguments.length>0) {
         Result+=" {"+TCustomDeclaration.GetAsCode$(Self.Arguments[0]);
         var $temp8;
         for(Index$2=0+1,$temp8=Self.Arguments.length;Index$2<$temp8;Index$2++) {
            Result+=", "+TCustomDeclaration.GetAsCode$(Self.Arguments[Index$2]);
         }
         Result+="} ";
      }
      return Result
   }
   ,Destroy:TObject.Destroy
   ,Create$10:TCustomDeclaration.Create$10
   ,GetAsCode$:function($){return $.ClassType.GetAsCode($)}
};
var TTypeParameter = {
   $ClassName:"TTypeParameter",$Parent:TCustomDeclaration
   ,$Init:function ($) {
      TCustomDeclaration.$Init($);
      $.Name = "";
      $.ExtendsType = null;
   }
   ,GetAsCode:function(Self) {
      var Result = "";
      Result = Self.Name;
      if (Self.ExtendsType) {
         Result+=" extends "+TCustomDeclaration.GetAsCode$(Self.ExtendsType);
      }
      return Result
   }
   ,Destroy:TObject.Destroy
   ,Create$10:TCustomDeclaration.Create$10
   ,GetAsCode$:function($){return $.ClassType.GetAsCode($)}
};
var TTypeOfType = {
   $ClassName:"TTypeOfType",$Parent:TCustomNamedType
   ,$Init:function ($) {
      TCustomNamedType.$Init($);
      $.Type = null;
   }
   ,GetName:function(Self) {
      var Result = "";
      Result = "type of";
      return Result
   }
   ,Destroy:TObject.Destroy
   ,Create$10:TCustomDeclaration.Create$10
   ,GetAsCode:TCustomNamedType.GetAsCode
   ,GetName$:function($){return $.ClassType.GetName($)}
};
var TTypeArgument = {
   $ClassName:"TTypeArgument",$Parent:TCustomDeclaration
   ,$Init:function ($) {
      TCustomDeclaration.$Init($);
      $.Type = null;
   }
   ,GetAsCode:function(Self) {
      var Result = "";
      if (Self.Type) {
         Result = TCustomDeclaration.GetAsCode$(Self.Type);
      } else {
         Result = "Variant";
      }
      return Result
   }
   ,Destroy:TObject.Destroy
   ,Create$10:TCustomDeclaration.Create$10
   ,GetAsCode$:function($){return $.ClassType.GetAsCode($)}
};
var TTypeAlias = {
   $ClassName:"TTypeAlias",$Parent:TNamedDeclaration
   ,$Init:function ($) {
      TNamedDeclaration.$Init($);
      $.Type = null;
      $.TypeParameters = [];
   }
   ,GetAsCode:function(Self) {
      var Result = "";
      Result = TCustomDeclaration.GetIndentionString(Self.ClassType)+Self.Name+" = "+TCustomDeclaration.GetAsCode$(Self.Type)+";"+"\r\n";
      return Result
   }
   ,Destroy:TObject.Destroy
   ,Create$10:TCustomDeclaration.Create$10
   ,GetAsCode$:function($){return $.ClassType.GetAsCode($)}
};
var TTupleType = {
   $ClassName:"TTupleType",$Parent:TCustomType
   ,$Init:function ($) {
      TCustomType.$Init($);
      $.Types = [];
   }
   ,GetAsCode:function(Self) {
      var Result = "";
      Result = "TupletType";
      return Result
   }
   ,Destroy:TObject.Destroy
   ,Create$10:TCustomDeclaration.Create$10
   ,GetAsCode$:function($){return $.ClassType.GetAsCode($)}
};
var TStringType = {
   $ClassName:"TStringType",$Parent:TPredefinedType
   ,$Init:function ($) {
      TPredefinedType.$Init($);
   }
   ,GetName:function(Self) {
      var Result = "";
      Result = "String";
      return Result
   }
   ,Destroy:TObject.Destroy
   ,Create$10:TCustomDeclaration.Create$10
   ,GetAsCode:TPredefinedType.GetAsCode
   ,GetName$:function($){return $.ClassType.GetName($)}
};
var TCustomTypeMember = {
   $ClassName:"TCustomTypeMember",$Parent:TNamedDeclaration
   ,$Init:function ($) {
      TNamedDeclaration.$Init($);
      $.TypeParameters = [];
      $.Visibility = 0;
      $.IsStatic = false;
      $.TypeArguments = [];
   }
   ,Create$10:function(Self, Owner$1) {
      TCustomDeclaration.Create$10(Self,Owner$1);
      Self.Visibility = 0;
      return Self
   }
   ,Destroy:TObject.Destroy
   ,Create$10$:function($){return $.ClassType.Create$10.apply($.ClassType, arguments)}
   ,GetAsCode:TCustomDeclaration.GetAsCode
};
var TClassTypeMember = {
   $ClassName:"TClassTypeMember",$Parent:TCustomTypeMember
   ,$Init:function ($) {
      TCustomTypeMember.$Init($);
      $.Visibility = 0;
      $.IsStatic = false;
   }
   ,Destroy:TObject.Destroy
   ,Create$10:TCustomTypeMember.Create$10
   ,GetAsCode:TCustomDeclaration.GetAsCode
};
var TPropertyMemberDeclaration = {
   $ClassName:"TPropertyMemberDeclaration",$Parent:TClassTypeMember
   ,$Init:function ($) {
      TClassTypeMember.$Init($);
      $.Nullable = false;
      $.Type = null;
   }
   ,GetAsCode:function(Self) {
      var Result = "";
      var a$290 = 0;
      var Argument = null;
      Result = TCustomDeclaration.GetIndentionString(Self.ClassType)+Escape(Self.Name);
      if (Self.TypeArguments.length>0) {
         var a$291 = [];
         Result+="{<";
         a$291 = Self.TypeArguments;
         var $temp9;
         for(a$290=0,$temp9=a$291.length;a$290<$temp9;a$290++) {
            Argument = a$291[a$290];
            Result+=TCustomDeclaration.GetAsCode$(Argument);
         }
         Result+=">}";
      }
      Result+=": ";
      if (Self.Type) {
         if ($Is(Self.Type,TObjectType)) {
            Result+="record"+"\r\n";
         }
         Result+=TCustomDeclaration.GetAsCode$(Self.Type);
      } else {
         Result+="Variant";
      }
      Result+=";";
      if (Self.Nullable) {
         Result+=" \/\/ nullable";
      }
      Result+="\r\n";
      return Result
   }
   ,Destroy:TObject.Destroy
   ,Create$10:TCustomTypeMember.Create$10
   ,GetAsCode$:function($){return $.ClassType.GetAsCode($)}
};
var TParameter = {
   $ClassName:"TParameter",$Parent:TNamedDeclaration
   ,$Init:function ($) {
      TNamedDeclaration.$Init($);
      $.DefaultValue = "";
      $.IsRest = $.IsOptional = false;
      $.AccessibilityModifier = 0;
      $.Type = null;
   }
   ,GetAsCode:function(Self) {
      var Result = "";
      Result = Self.Name+": ";
      if (Self.Type) {
         if ($Is(Self.Type,TObjectType)) {
            Result+="record"+"\r\n";
         }
         Result+=TCustomDeclaration.GetAsCode$(Self.Type);
      } else {
         Result+="Variant";
      }
      if (Self.DefaultValue!="") {
         Result+=" = "+Self.DefaultValue;
      }
      if (Self.IsRest) {
         Result+=" {...}";
      }
      return Result
   }
   ,GetAsCodeOmitType:function(Self, OmitType) {
      var Result = "";
      var ResType = null;
      Result = Escape(Self.Name);
      if (!OmitType) {
         Result+=": ";
         if (Self.Type) {
            if ($Is(Self.Type,TObjectType)) {
               Result+="record"+"\r\n";
            }
            if ($Is(Self.Type,TFunctionType)) {
               ResType = $As(Self.Type,TFunctionType).ResultType;
               Result+=(ResType)?"function":"procedure";
            }
            Result+=TCustomDeclaration.GetAsCode$(Self.Type);
         } else {
            Result+="Variant";
         }
      }
      return Result
   }
   ,Destroy:TObject.Destroy
   ,Create$10:TCustomDeclaration.Create$10
   ,GetAsCode$:function($){return $.ClassType.GetAsCode($)}
};
var TObjectType = {
   $ClassName:"TObjectType",$Parent:TCustomType
   ,$Init:function ($) {
      TCustomType.$Init($);
      $.Members = [];
   }
   ,GetAsCode:function(Self) {
      var Result = "";
      var a$292 = 0;
      var Member$1 = null,
         ResType$1 = null;
      var a$293 = [];
      TCustomDeclaration.BeginIndention(Self.ClassType);
      a$293 = Self.Members;
      var $temp10;
      for(a$292=0,$temp10=a$293.length;a$292<$temp10;a$292++) {
         Member$1 = a$293[a$292];
         if ($Is(Member$1,TCallSignature)) {
            Result+=TCustomDeclaration.GetIndentionString(Self.ClassType);
            ResType$1 = $As(Member$1,TCallSignature).Type;
            Result+=(ResType$1)?"function":"procedure";
            Result+=TCustomDeclaration.GetAsCode$(Member$1)+";"+"\r\n";
         } else {
            Result+=TCustomDeclaration.GetAsCode$(Member$1);
         }
      }
      TCustomDeclaration.EndIndention(Self.ClassType);
      Result+=TCustomDeclaration.GetIndentionString(Self.ClassType)+"end";
      return Result
   }
   ,Destroy:TObject.Destroy
   ,Create$10:TCustomDeclaration.Create$10
   ,GetAsCode$:function($){return $.ClassType.GetAsCode($)}
};
var TNamespaceDeclaration = {
   $ClassName:"TNamespaceDeclaration",$Parent:TNamedDeclaration
   ,$Init:function ($) {
      TNamedDeclaration.$Init($);
      $.Namespaces = [];
      $.Interfaces = [];
      $.Classes = [];
      $.Functions = [];
      $.TypeAliases = [];
      $.Enums = [];
   }
   ,GetAsCode:function(Self) {
      var Result = "";
      var a$294 = 0;
      var Enum = null,
         a$295 = 0;
      var Class = null,
         a$296 = 0;
      var Interface$2 = null,
         a$297 = 0;
      var Function$2 = null,
         a$298 = 0;
      var Namespace = null;
      var a$299 = [];
      TCustomDeclaration.BeginNamespace(Self.ClassType,Self.Name);
      if (Self.Enums.length+Self.Classes.length+Self.Interfaces.length>0) {
         var a$300 = [],
             a$301 = [],
             a$302 = [];
         Result+="type"+"\r\n";
         TCustomDeclaration.BeginIndention(Self.ClassType);
         a$302 = Self.Enums;
         var $temp11;
         for(a$294=0,$temp11=a$302.length;a$294<$temp11;a$294++) {
            Enum = a$302[a$294];
            Result+=TCustomDeclaration.GetAsCode$(Enum);
         }
         a$301 = Self.Classes;
         var $temp12;
         for(a$295=0,$temp12=a$301.length;a$295<$temp12;a$295++) {
            Class = a$301[a$295];
            Result+=TCustomDeclaration.GetAsCode$(Class);
         }
         a$300 = Self.Interfaces;
         var $temp13;
         for(a$296=0,$temp13=a$300.length;a$296<$temp13;a$296++) {
            Interface$2 = a$300[a$296];
            Result+=TCustomDeclaration.GetAsCode$(Interface$2);
         }
         TCustomDeclaration.EndIndention(Self.ClassType);
      }
      if (Self.Functions.length>0) {
         var a$303 = [];
         a$303 = Self.Functions;
         var $temp14;
         for(a$297=0,$temp14=a$303.length;a$297<$temp14;a$297++) {
            Function$2 = a$303[a$297];
            Result+=TCustomDeclaration.GetAsCode$(Function$2);
         }
         Result+="\r\n";
      }
      a$299 = Self.Namespaces;
      var $temp15;
      for(a$298=0,$temp15=a$299.length;a$298<$temp15;a$298++) {
         Namespace = a$299[a$298];
         Result+=TCustomDeclaration.GetAsCode$(Namespace);
      }
      Result+="\r\n";
      TCustomDeclaration.EndNamespace(Self.ClassType);
      return Result
   }
   ,Destroy:TObject.Destroy
   ,Create$10:TCustomDeclaration.Create$10
   ,GetAsCode$:function($){return $.ClassType.GetAsCode($)}
};
var TNamedType = {
   $ClassName:"TNamedType",$Parent:TCustomNamedType
   ,$Init:function ($) {
      TCustomNamedType.$Init($);
      $.Arguments = [];
      $.FName = "";
   }
   ,Create$12:function(Self, Owner$2, AName) {
      TCustomDeclaration.Create$10(Self,Owner$2);
      Self.FName = AName;
      return Self
   }
   ,GetAsCode:function(Self) {
      var Result = "";
      var a$304 = 0;
      var Argument$1 = null;
      Result = TCustomNamedType.GetAsCode(Self);
      if (Self.Arguments.length>0) {
         var a$305 = [];
         Result+="{<";
         a$305 = Self.Arguments;
         var $temp16;
         for(a$304=0,$temp16=a$305.length;a$304<$temp16;a$304++) {
            Argument$1 = a$305[a$304];
            Result+=TCustomDeclaration.GetAsCode$(Argument$1);
         }
         Result+=">}";
      }
      return Result
   }
   ,GetName:function(Self) {
      var Result = "";
      Result = Self.FName;
      return Result
   }
   ,Destroy:TObject.Destroy
   ,Create$10:TCustomDeclaration.Create$10
   ,GetAsCode$:function($){return $.ClassType.GetAsCode($)}
   ,GetName$:function($){return $.ClassType.GetName($)}
};
var TModuleDeclaration = {
   $ClassName:"TModuleDeclaration",$Parent:TNamedDeclaration
   ,$Init:function ($) {
      TNamedDeclaration.$Init($);
      $.Modules = [];
      $.Variables = [];
      $.Exports = [];
      $.Functions = [];
      $.Interfaces = [];
      $.Classes = [];
   }
   ,GetAsCode:function(Self) {
      var Result = "";
      var a$306 = 0;
      var Class$1 = null,
         a$307 = 0;
      var Interface$3 = null,
         a$308 = 0;
      var Variable$1 = null;
      Result = "";
      if (Self.Classes.length+Self.Interfaces.length>0) {
         var a$309 = [],
             a$310 = [];
         Result+="type"+"\r\n";
         TCustomDeclaration.BeginIndention(Self.ClassType);
         a$310 = Self.Classes;
         var $temp17;
         for(a$306=0,$temp17=a$310.length;a$306<$temp17;a$306++) {
            Class$1 = a$310[a$306];
            Result = Result+TCustomDeclaration.GetAsCode$(Class$1);
         }
         a$309 = Self.Interfaces;
         var $temp18;
         for(a$307=0,$temp18=a$309.length;a$307<$temp18;a$307++) {
            Interface$3 = a$309[a$307];
            Result = Result+TCustomDeclaration.GetAsCode$(Interface$3);
         }
         TCustomDeclaration.EndIndention(Self.ClassType);
      }
      if (Self.Variables.length>0) {
         var a$311 = [];
         Result+="var"+"\r\n";
         TCustomDeclaration.BeginIndention(Self.ClassType);
         a$311 = Self.Variables;
         var $temp19;
         for(a$308=0,$temp19=a$311.length;a$308<$temp19;a$308++) {
            Variable$1 = a$311[a$308];
            Result = Result+TCustomDeclaration.GetAsCode$(Variable$1);
         }
         TCustomDeclaration.EndIndention(Self.ClassType);
      }
      return Result
   }
   ,Destroy:TObject.Destroy
   ,Create$10:TCustomDeclaration.Create$10
   ,GetAsCode$:function($){return $.ClassType.GetAsCode($)}
};
var TMethodDeclaration = {
   $ClassName:"TMethodDeclaration",$Parent:TClassTypeMember
   ,$Init:function ($) {
      TClassTypeMember.$Init($);
      $.CallSignature = null;
   }
   ,GetAsCode:function(Self) {
      var Result = "";
      var Head = "";
      var Foot = "";
      var OptionalParameterCount = 0,
         a$312 = 0;
      var Parameter = null,
         i = 0;
      var a$313 = [];
      OptionalParameterCount = 0;
      a$313 = Self.CallSignature.ParameterList;
      var $temp20;
      for(a$312=0,$temp20=a$313.length;a$312<$temp20;a$312++) {
         Parameter = a$313[a$312];
         if (Parameter.IsOptional) {
            ++OptionalParameterCount;
         }
      }
      Head = TCustomDeclaration.GetIndentionString(Self.ClassType);
      Head+=(Self.CallSignature.Type)?"function":"procedure";
      Head+=" "+Escape(Self.Name);
      Foot = ";";
      Foot+=(OptionalParameterCount>0)?" overload;":"";
      Foot+="\r\n";
      Result = "";
      var $temp21;
      for(i=0,$temp21=OptionalParameterCount;i<=$temp21;i++) {
         Result+=Head+TCallSignature.GetAsCodeWithOptionalLevel$1(Self.CallSignature,i)+Foot;
      }
      return Result
   }
   ,Destroy:TObject.Destroy
   ,Create$10:TCustomTypeMember.Create$10
   ,GetAsCode$:function($){return $.ClassType.GetAsCode($)}
};
var TInterfaceDeclaration = {
   $ClassName:"TInterfaceDeclaration",$Parent:TCustomDeclaration
   ,$Init:function ($) {
      TCustomDeclaration.$Init($);
      $.TypeParameters = [];
      $.Type = null;
      $.Name = "";
      $.Extends = [];
      $.IsExport = false;
   }
   ,GetAsCode:function(Self) {
      var Result = "";
      var a$314 = 0;
      var TypeParameter = null,
         Index$3 = 0;
      Result+=TCustomDeclaration.GetIndentionString(Self.ClassType)+"J"+Self.Name;
      if (Self.TypeParameters.length>0) {
         var a$315 = [];
         Result+="{<";
         a$315 = Self.TypeParameters;
         var $temp22;
         for(a$314=0,$temp22=a$315.length;a$314<$temp22;a$314++) {
            TypeParameter = a$315[a$314];
            Result+=TCustomDeclaration.GetAsCode$(TypeParameter);
         }
         Result+=">}";
      }
      Result+=" = class external";
      if (Self.Extends.length>0) {
         Result+="(";
         Result+=TCustomDeclaration.GetAsCode$(Self.Extends[0]);
         var $temp23;
         for(Index$3=0+1,$temp23=Self.Extends.length;Index$3<$temp23;Index$3++) {
            Result+=", "+TCustomDeclaration.GetAsCode$(Self.Extends[Index$3]);
         }
         Result+=")";
      }
      Result+="\r\n";
      Result+=TCustomDeclaration.GetAsCode$(Self.Type);
      Result+=";"+"\r\n"+"\r\n";
      return Result
   }
   ,Destroy:TObject.Destroy
   ,Create$10:TCustomDeclaration.Create$10
   ,GetAsCode$:function($){return $.ClassType.GetAsCode($)}
};
var TIndexSignature = {
   $ClassName:"TIndexSignature",$Parent:TCustomTypeMember
   ,$Init:function ($) {
      TCustomTypeMember.$Init($);
      $.IsStringIndex = false;
      $.Type = null;
   }
   ,GetAsCode:function(Self) {
      var Result = "";
      Result = TCustomDeclaration.GetIndentionString(Self.ClassType)+"\/\/ ";
      Result+="property Item["+Self.Name+": ";
      Result+=(Self.IsStringIndex)?"String":"Integer";
      Result+="]: "+TCustomDeclaration.GetAsCode$(Self.Type)+";"+"\r\n";
      return Result
   }
   ,Destroy:TObject.Destroy
   ,Create$10:TCustomTypeMember.Create$10
   ,GetAsCode$:function($){return $.ClassType.GetAsCode($)}
};
var TIndexMemberDeclaration = {
   $ClassName:"TIndexMemberDeclaration",$Parent:TClassTypeMember
   ,$Init:function ($) {
      TClassTypeMember.$Init($);
      $.IndexSignature = null;
   }
   ,GetAsCode:function(Self) {
      var Result = "";
      Result = TCustomDeclaration.GetAsCode$(Self.IndexSignature)+";"+"\r\n";
      return Result
   }
   ,Destroy:TObject.Destroy
   ,Create$10:TCustomTypeMember.Create$10
   ,GetAsCode$:function($){return $.ClassType.GetAsCode($)}
};
var TImportDeclaration = {
   $ClassName:"TImportDeclaration",$Parent:TNamedDeclaration
   ,$Init:function ($) {
      TNamedDeclaration.$Init($);
      $.Value = "";
   }
   ,GetAsCode:function(Self) {
      var Result = "";
      console.log("not implemented: TImportDeclaration.GetAsCode");
      return Result
   }
   ,Destroy:TObject.Destroy
   ,Create$10:TCustomDeclaration.Create$10
   ,GetAsCode$:function($){return $.ClassType.GetAsCode($)}
};
var TFunctionType = {
   $ClassName:"TFunctionType",$Parent:TCustomNamedType
   ,$Init:function ($) {
      TCustomNamedType.$Init($);
      $.TypeParameters = [];
      $.ParameterList = [];
      $.ResultType = null;
   }
   ,GetAsCode:function(Self) {
      var Result = "";
      var Index$4 = 0;
      if (Self.ParameterList.length>0) {
         Result = "("+TFunctionParameter.GetAsCodeOmitType$1(Self.ParameterList[0],false);
         var $temp24;
         for(Index$4=0+1,$temp24=Self.ParameterList.length;Index$4<$temp24;Index$4++) {
            Result+="; "+TFunctionParameter.GetAsCodeOmitType$1(Self.ParameterList[Index$4],false);
         }
         Result+=")";
      }
      if (Self.ResultType) {
         Result+=": "+TCustomDeclaration.GetAsCode$(Self.ResultType);
      }
      return Result
   }
   ,GetAsCodeWithOptionalLevel:function(Self, OptionalLevel) {
      var Result = "";
      var CanOmitType = false;
      var CurrentOptionalLevel = 0,
         Index$5 = 0;
      CurrentOptionalLevel = 0;
      if (Self.ParameterList.length>0) {
         if (!(Self.ParameterList[0].IsOptional&&OptionalLevel==0)) {
            CurrentOptionalLevel+=(Self.ParameterList[0].IsOptional?1:0);
            CanOmitType = Self.ParameterList.length>=2&&IsIdenticalFunctionParameterType(Self.ParameterList[0],Self.ParameterList[1])&&((!Self.ParameterList[0].IsOptional)||CurrentOptionalLevel<OptionalLevel);
            Result = "("+TFunctionParameter.GetAsCodeOmitType$1(Self.ParameterList[0],CanOmitType);
            var $temp25;
            for(Index$5=0+1,$temp25=Self.ParameterList.length;Index$5<$temp25;Index$5++) {
               if (Self.ParameterList[Index$5].IsOptional&&CurrentOptionalLevel>=OptionalLevel) {
                  break;
               }
               CurrentOptionalLevel+=(Self.ParameterList[Index$5].IsOptional?1:0);
               Result+=(CanOmitType)?", ":"; ";
               CanOmitType = Index$5+1<Self.ParameterList.length&&IsIdenticalFunctionParameterType(Self.ParameterList[0],Self.ParameterList[1])&&((!Self.ParameterList[Index$5].IsOptional)||CurrentOptionalLevel<OptionalLevel);
               Result+=TFunctionParameter.GetAsCodeOmitType$1(Self.ParameterList[Index$5],CanOmitType);
            }
            Result+=")";
         }
      }
      if (Self.ResultType) {
         Result+=": "+TCustomDeclaration.GetAsCode$(Self.ResultType);
      }
      return Result
   }
   ,GetName:function(Self) {
      var Result = "";
      Result = "function";
      return Result
   }
   ,Destroy:TObject.Destroy
   ,Create$10:TCustomDeclaration.Create$10
   ,GetAsCode$:function($){return $.ClassType.GetAsCode($)}
   ,GetName$:function($){return $.ClassType.GetName($)}
};
var TFunctionParameter = {
   $ClassName:"TFunctionParameter",$Parent:TNamedDeclaration
   ,$Init:function ($) {
      TNamedDeclaration.$Init($);
      $.Type = null;
      $.IsOptional = false;
   }
   ,GetAsCode:function(Self) {
      var Result = "";
      Result = Escape(Self.Name)+": ";
      if (Self.Type) {
         if ($Is(Self.Type,TObjectType)) {
            Result+="record"+"\r\n";
         }
         Result+=TCustomDeclaration.GetAsCode$(Self.Type);
      } else {
         Result+="Variant";
      }
      return Result
   }
   ,GetAsCodeOmitType$1:function(Self, OmitType$1) {
      var Result = "";
      Result = Escape(Self.Name);
      if (!OmitType$1) {
         Result+=": ";
         if (Self.Type) {
            if ($Is(Self.Type,TObjectType)) {
               Result+="record"+"\r\n";
            }
            Result+=TCustomDeclaration.GetAsCode$(Self.Type);
         } else {
            Result+="Variant";
         }
      }
      return Result
   }
   ,Destroy:TObject.Destroy
   ,Create$10:TCustomDeclaration.Create$10
   ,GetAsCode$:function($){return $.ClassType.GetAsCode($)}
};
var TFunctionDeclaration = {
   $ClassName:"TFunctionDeclaration",$Parent:TNamedDeclaration
   ,$Init:function ($) {
      TNamedDeclaration.$Init($);
      $.Type = null;
   }
   ,GetAsCode:function(Self) {
      var Result = "";
      var Head$1 = "";
      var Foot$1 = "";
      var OptionalParameterCount$1 = 0,
         a$316 = 0;
      var Parameter$1 = null,
         i$1 = 0;
      var a$317 = [];
      OptionalParameterCount$1 = 0;
      a$317 = Self.Type.ParameterList;
      var $temp26;
      for(a$316=0,$temp26=a$317.length;a$316<$temp26;a$316++) {
         Parameter$1 = a$317[a$316];
         if (Parameter$1.IsOptional) {
            ++OptionalParameterCount$1;
         }
      }
      Head$1 = TCustomDeclaration.GetIndentionString(Self.ClassType);
      Head$1+=(Self.Type.ResultType)?"function":"procedure";
      Head$1+=" "+Escape(Self.Name);
      Foot$1 = ";"+((OptionalParameterCount$1>0)?" overload;":"");
      Foot$1+="\r\n";
      Result = "";
      var $temp27;
      for(i$1=0,$temp27=OptionalParameterCount$1;i$1<=$temp27;i$1++) {
         Result+=Head$1+TFunctionType.GetAsCodeWithOptionalLevel(Self.Type,i$1)+Foot$1;
      }
      return Result
   }
   ,Destroy:TObject.Destroy
   ,Create$10:TCustomDeclaration.Create$10
   ,GetAsCode$:function($){return $.ClassType.GetAsCode($)}
};
var TFloatType = {
   $ClassName:"TFloatType",$Parent:TPredefinedType
   ,$Init:function ($) {
      TPredefinedType.$Init($);
   }
   ,GetName:function(Self) {
      var Result = "";
      Result = "Float";
      return Result
   }
   ,Destroy:TObject.Destroy
   ,Create$10:TCustomDeclaration.Create$10
   ,GetAsCode:TPredefinedType.GetAsCode
   ,GetName$:function($){return $.ClassType.GetName($)}
};
var TExportDeclaration = {
   $ClassName:"TExportDeclaration",$Parent:TNamedDeclaration
   ,$Init:function ($) {
      TNamedDeclaration.$Init($);
      $.FDefault = false;
   }
   ,GetAsCode:function(Self) {
      var Result = "";
      Result = "";
      return Result
   }
   ,Destroy:TObject.Destroy
   ,Create$10:TCustomDeclaration.Create$10
   ,GetAsCode$:function($){return $.ClassType.GetAsCode($)}
};
var TEnumerationItem = {
   $ClassName:"TEnumerationItem",$Parent:TCustomDeclaration
   ,$Init:function ($) {
      TCustomDeclaration.$Init($);
      $.Name = $.Value = "";
   }
   ,GetAsCode:function(Self) {
      var Result = "";
      Result = Self.Name;
      return Result
   }
   ,Destroy:TObject.Destroy
   ,Create$10:TCustomDeclaration.Create$10
   ,GetAsCode$:function($){return $.ClassType.GetAsCode($)}
};
var TEnumerationDeclaration = {
   $ClassName:"TEnumerationDeclaration",$Parent:TNamedDeclaration
   ,$Init:function ($) {
      TNamedDeclaration.$Init($);
      $.Items = [];
   }
   ,GetAsCode:function(Self) {
      var Result = "";
      var a$318 = 0;
      var Item = null;
      var a$319 = [];
      Result+=TCustomDeclaration.GetIndentionString(Self.ClassType)+"T"+Self.Name+" = Variant;"+"\r\n";
      Result+=TCustomDeclaration.GetIndentionString(Self.ClassType)+"T"+Self.Name+"Helper = strict helper for T"+Self.Name+"\r\n";
      TCustomDeclaration.BeginIndention(Self.ClassType);
      a$319 = Self.Items;
      var $temp28;
      for(a$318=0,$temp28=a$319.length;a$318<$temp28;a$318++) {
         Item = a$319[a$318];
         Result+=TCustomDeclaration.GetIndentionString(Self.ClassType)+"const "+Escape(TCustomDeclaration.GetAsCode$(Item));
         if (Item.Value!="") {
            try {
               Result+=" = "+(parseInt(Item.Value,10)).toString()+";"+"\r\n";
            } catch ($e) {
               Result+=" = '"+Item.Value+"';"+"\r\n";
            }
         } else {
            Result+=" = '"+Item.Name+"';"+"\r\n";
         }
      }
      TCustomDeclaration.EndIndention(Self.ClassType);
      Result+=TCustomDeclaration.GetIndentionString(Self.ClassType)+"end;"+"\r\n";
      Result+="\r\n";
      return Result
   }
   ,Destroy:TObject.Destroy
   ,Create$10:TCustomDeclaration.Create$10
   ,GetAsCode$:function($){return $.ClassType.GetAsCode($)}
};
var TDefinitionDeclaration = {
   $ClassName:"TDefinitionDeclaration",$Parent:TNamedDeclaration
   ,$Init:function ($) {
      TNamedDeclaration.$Init($);
   }
   ,GetAsCode:function(Self) {
      var Result = "";
      console.log("not implemented: TDefinitionDeclaration.GetAsCode");
      return Result
   }
   ,Destroy:TObject.Destroy
   ,Create$10:TCustomDeclaration.Create$10
   ,GetAsCode$:function($){return $.ClassType.GetAsCode($)}
};
var TConstructorType = {
   $ClassName:"TConstructorType",$Parent:TCustomNamedType
   ,$Init:function ($) {
      TCustomNamedType.$Init($);
      $.ResultType = null;
      $.ParameterList = [];
   }
   ,GetAsCode:function(Self) {
      var Result = "";
      var Index$6 = 0;
      if (Self.ParameterList.length>0) {
         Result = "("+TFunctionParameter.GetAsCodeOmitType$1(Self.ParameterList[0],false);
         var $temp29;
         for(Index$6=0+1,$temp29=Self.ParameterList.length;Index$6<$temp29;Index$6++) {
            Result+="; "+TFunctionParameter.GetAsCodeOmitType$1(Self.ParameterList[Index$6],false);
         }
         Result+=")";
      }
      if (Self.ResultType) {
         Result+=": "+TCustomDeclaration.GetAsCode$(Self.ResultType);
      }
      return Result
   }
   ,GetName:function(Self) {
      var Result = "";
      Result = "constructor";
      return Result
   }
   ,Destroy:TObject.Destroy
   ,Create$10:TCustomDeclaration.Create$10
   ,GetAsCode$:function($){return $.ClassType.GetAsCode($)}
   ,GetName$:function($){return $.ClassType.GetName($)}
};
var TConstructorDeclaration = {
   $ClassName:"TConstructorDeclaration",$Parent:TClassTypeMember
   ,$Init:function ($) {
      TClassTypeMember.$Init($);
      $.ParameterList = [];
      $.Type = null;
   }
   ,GetAsCode:function(Self) {
      var Result = "";
      Result = TCustomDeclaration.GetIndentionString(Self.ClassType)+"constructor Create";
      if (Self.Type) {
         Result+=TCustomDeclaration.GetAsCode$(Self.Type);
      }
      Result+=";"+"\r\n";
      return Result
   }
   ,Destroy:TObject.Destroy
   ,Create$10:TCustomTypeMember.Create$10
   ,GetAsCode$:function($){return $.ClassType.GetAsCode($)}
};
var TClassDeclaration = {
   $ClassName:"TClassDeclaration",$Parent:TInterfaceDeclaration
   ,$Init:function ($) {
      TInterfaceDeclaration.$Init($);
      $.Members = [];
      $.IsAbstract = false;
      $.Implements = [];
   }
   ,GetAsCode:function(Self) {
      var Result = "";
      var Index$7 = 0;
      var a$320 = 0;
      var Member$2 = null;
      var a$321 = [];
      Result+=TCustomDeclaration.GetIndentionString(Self.ClassType)+"J"+Self.Name+" = class external '"+Self.Name+"'";
      if (Self.Extends.length>0) {
         Result+="(";
         Result+=TCustomDeclaration.GetAsCode$(Self.Extends[0]);
         var $temp30;
         for(Index$7=0+1,$temp30=Self.Extends.length;Index$7<$temp30;Index$7++) {
            Result+=", "+TCustomDeclaration.GetAsCode$(Self.Extends[Index$7]);
         }
         Result+=")";
      }
      Result+="\r\n";
      TCustomDeclaration.BeginIndention(Self.ClassType);
      a$321 = Self.Members;
      var $temp31;
      for(a$320=0,$temp31=a$321.length;a$320<$temp31;a$320++) {
         Member$2 = a$321[a$320];
         Result+=TCustomDeclaration.GetAsCode$(Member$2);
      }
      TCustomDeclaration.EndIndention(Self.ClassType);
      Result+=TCustomDeclaration.GetIndentionString(Self.ClassType)+"end;"+"\r\n"+"\r\n";
      return Result
   }
   ,Destroy:TObject.Destroy
   ,Create$10:TCustomDeclaration.Create$10
   ,GetAsCode$:function($){return $.ClassType.GetAsCode($)}
};
var TCallSignature = {
   $ClassName:"TCallSignature",$Parent:TCustomTypeMember
   ,$Init:function ($) {
      TCustomTypeMember.$Init($);
      $.ParameterList = [];
      $.Type = null;
      $.TypeParameters = [];
   }
   ,GetAsCode:function(Self) {
      var Result = "";
      var a$322 = 0;
      var TypeParameter$1 = null,
         Index$8 = 0;
      Result = "";
      if (Self.TypeParameters.length>0) {
         var a$323 = [];
         Result+="{<";
         a$323 = Self.TypeParameters;
         var $temp32;
         for(a$322=0,$temp32=a$323.length;a$322<$temp32;a$322++) {
            TypeParameter$1 = a$323[a$322];
            Result+=TCustomDeclaration.GetAsCode$(TypeParameter$1);
         }
         Result+=">}";
      }
      if (Self.ParameterList.length>0) {
         Result+="(";
         var $temp33;
         for(Index$8=0,$temp33=(Self.ParameterList.length-1);Index$8<$temp33;Index$8++) {
            Result+=TParameter.GetAsCodeOmitType(Self.ParameterList[Index$8],false)+"; ";
         }
         Result+=TParameter.GetAsCodeOmitType(Self.ParameterList[(Self.ParameterList.length-1)],false)+")";
      }
      if (Self.Type) {
         Result+=": ";
         if ($Is(Self.Type,TObjectType)) {
            Result+="record"+"\r\n";
         }
         Result+=TCustomDeclaration.GetAsCode$(Self.Type);
      }
      Result+=";";
      return Result
   }
   ,GetAsCodeWithOptionalLevel$1:function(Self, OptionalLevel$1) {
      var Result = "";
      var CanOmitType$1 = false;
      var CurrentOptionalLevel$1 = 0,
         Index$9 = 0;
      CurrentOptionalLevel$1 = 0;
      if (Self.ParameterList.length>0) {
         if (!(Self.ParameterList[0].IsOptional&&OptionalLevel$1==0)) {
            CurrentOptionalLevel$1+=(Self.ParameterList[0].IsOptional?1:0);
            CanOmitType$1 = Self.ParameterList.length>=2&&IsIdenticalParameterType(Self.ParameterList[0],Self.ParameterList[1])&&((!Self.ParameterList[0].IsOptional)||CurrentOptionalLevel$1<OptionalLevel$1);
            Result = "("+TParameter.GetAsCodeOmitType(Self.ParameterList[0],CanOmitType$1);
            var $temp34;
            for(Index$9=0+1,$temp34=Self.ParameterList.length;Index$9<$temp34;Index$9++) {
               if (Self.ParameterList[Index$9].IsOptional&&CurrentOptionalLevel$1>=OptionalLevel$1) {
                  break;
               }
               CurrentOptionalLevel$1+=(Self.ParameterList[Index$9].IsOptional?1:0);
               Result+=(CanOmitType$1)?", ":"; ";
               CanOmitType$1 = Index$9+1<Self.ParameterList.length&&IsIdenticalParameterType(Self.ParameterList[Index$9],Self.ParameterList[Index$9+1])&&((!Self.ParameterList[Index$9].IsOptional)||CurrentOptionalLevel$1<OptionalLevel$1);
               Result+=TParameter.GetAsCodeOmitType(Self.ParameterList[Index$9],CanOmitType$1);
            }
            Result+=")";
         }
      }
      if (Self.Type) {
         Result+=": ";
         if ($Is(Self.Type,TObjectType)) {
            Result+="record"+"\r\n";
         }
         Result+=TCustomDeclaration.GetAsCode$(Self.Type);
      }
      return Result
   }
   ,Destroy:TObject.Destroy
   ,Create$10:TCustomTypeMember.Create$10
   ,GetAsCode$:function($){return $.ClassType.GetAsCode($)}
};
var TBooleanType = {
   $ClassName:"TBooleanType",$Parent:TPredefinedType
   ,$Init:function ($) {
      TPredefinedType.$Init($);
   }
   ,GetName:function(Self) {
      var Result = "";
      Result = "Boolean";
      return Result
   }
   ,Destroy:TObject.Destroy
   ,Create$10:TCustomDeclaration.Create$10
   ,GetAsCode:TPredefinedType.GetAsCode
   ,GetName$:function($){return $.ClassType.GetName($)}
};
var TArrayType = {
   $ClassName:"TArrayType",$Parent:TCustomType
   ,$Init:function ($) {
      TCustomType.$Init($);
      $.Type = null;
   }
   ,GetAsCode:function(Self) {
      var Result = "";
      Result = "array of "+TCustomDeclaration.GetAsCode$(Self.Type);
      return Result
   }
   ,Destroy:TObject.Destroy
   ,Create$10:TCustomDeclaration.Create$10
   ,GetAsCode$:function($){return $.ClassType.GetAsCode($)}
};
var TAmbientVariableDeclaration = {
   $ClassName:"TAmbientVariableDeclaration",$Parent:TCustomDeclaration
   ,$Init:function ($) {
      TCustomDeclaration.$Init($);
      $.IsConst = false;
      $.AmbientBindingList = [];
   }
   ,GetAsCode:function(Self) {
      var Result = "";
      var a$324 = 0;
      var AmbientBinding = null;
      var a$325 = [];
      a$325 = Self.AmbientBindingList;
      var $temp35;
      for(a$324=0,$temp35=a$325.length;a$324<$temp35;a$324++) {
         AmbientBinding = a$325[a$324];
         Result+=TCustomDeclaration.GetIndentionString(Self.ClassType)+TCustomDeclaration.GetAsCode$(AmbientBinding);
      }
      Result+=";"+"\r\n";
      return Result
   }
   ,Destroy:TObject.Destroy
   ,Create$10:TCustomDeclaration.Create$10
   ,GetAsCode$:function($){return $.ClassType.GetAsCode($)}
};
var TAmbientBodyElement = {
   $ClassName:"TAmbientBodyElement",$Parent:TCustomDeclaration
   ,$Init:function ($) {
      TCustomDeclaration.$Init($);
   }
   ,Destroy:TObject.Destroy
   ,Create$10:TCustomDeclaration.Create$10
   ,GetAsCode:TCustomDeclaration.GetAsCode
};
var TAmbientPropertyMemberDeclaration = {
   $ClassName:"TAmbientPropertyMemberDeclaration",$Parent:TAmbientBodyElement
   ,$Init:function ($) {
      TAmbientBodyElement.$Init($);
      $.Visibility = 0;
      $.IsStatic = false;
      $.Name = "";
   }
   ,Destroy:TObject.Destroy
   ,Create$10:TCustomDeclaration.Create$10
   ,GetAsCode:TCustomDeclaration.GetAsCode
};
var TAmbientPropertyMemberDeclarationProperty = {
   $ClassName:"TAmbientPropertyMemberDeclarationProperty",$Parent:TAmbientPropertyMemberDeclaration
   ,$Init:function ($) {
      TAmbientPropertyMemberDeclaration.$Init($);
      $.Type = null;
   }
   ,GetAsCode:function(Self) {
      var Result = "";
      Result = TCustomDeclaration.GetIndentionString(Self.ClassType);
      if (Self.IsStatic) {
         Result+="class var ";
      }
      Result+=Escape(Self.Name);
      Result+=": "+((Self.Type)?TCustomDeclaration.GetAsCode$(Self.Type):"Variant");
      Result+=";"+"\r\n";
      return Result
   }
   ,Destroy:TObject.Destroy
   ,Create$10:TCustomDeclaration.Create$10
   ,GetAsCode$:function($){return $.ClassType.GetAsCode($)}
};
var TAmbientPropertyMemberDeclarationMethod = {
   $ClassName:"TAmbientPropertyMemberDeclarationMethod",$Parent:TAmbientPropertyMemberDeclaration
   ,$Init:function ($) {
      TAmbientPropertyMemberDeclaration.$Init($);
      $.CallSignature = null;
   }
   ,GetAsCode:function(Self) {
      var Result = "";
      var Head$2 = "";
      var Foot$2 = "";
      var OptionalParameterCount$2 = 0,
         a$326 = 0;
      var Parameter$2 = null,
         i$2 = 0;
      var a$327 = [];
      OptionalParameterCount$2 = 0;
      a$327 = Self.CallSignature.ParameterList;
      var $temp36;
      for(a$326=0,$temp36=a$327.length;a$326<$temp36;a$326++) {
         Parameter$2 = a$327[a$326];
         if (Parameter$2.IsOptional) {
            ++OptionalParameterCount$2;
         }
      }
      Head$2 = TCustomDeclaration.GetIndentionString(Self.ClassType);
      Head$2+=(Self.CallSignature.Type)?"function":"procedure";
      Head$2+=" "+Escape(Self.Name);
      Foot$2 = (OptionalParameterCount$2>0)?" overload;":"";
      Foot$2+=";"+"\r\n";
      Result = "";
      var $temp37;
      for(i$2=0,$temp37=OptionalParameterCount$2;i$2<=$temp37;i$2++) {
         Result+=Head$2+TCallSignature.GetAsCodeWithOptionalLevel$1(Self.CallSignature,i$2)+Foot$2;
      }
      return Result
   }
   ,Destroy:TObject.Destroy
   ,Create$10:TCustomDeclaration.Create$10
   ,GetAsCode$:function($){return $.ClassType.GetAsCode($)}
};
var TAmbientNamespaceDeclaration = {
   $ClassName:"TAmbientNamespaceDeclaration",$Parent:TNamedDeclaration
   ,$Init:function ($) {
      TNamedDeclaration.$Init($);
      $.TypeAliases = [];
      $.Namespaces = [];
      $.Variables = [];
      $.Interfaces = [];
      $.Enums = [];
      $.Functions = [];
      $.Classes = [];
   }
   ,GetAsCode:function(Self) {
      var Result = "";
      var Constants = 0,
         a$328 = 0;
      var Variable$2 = null,
         a$329 = 0;
      var Variable$3 = null,
         a$330 = 0;
      var Enum$1 = null,
         a$331 = 0;
      var Class$2 = null,
         a$332 = 0;
      var Interface$4 = null,
         a$333 = 0;
      var TypeAlias = null,
         a$334 = 0;
      var Function$3 = null,
         a$335 = 0;
      var Variable$4 = null,
         a$336 = 0;
      var Namespace$1 = null;
      var a$337 = [],
          a$338 = [];
      TCustomDeclaration.BeginNamespace(Self.ClassType,Self.Name);
      Constants = 0;
      a$338 = Self.Variables;
      var $temp38;
      for(a$328=0,$temp38=a$338.length;a$328<$temp38;a$328++) {
         Variable$2 = a$338[a$328];
         if (Variable$2.IsConst) {
            ++Constants;
         }
      }
      if (Constants>0) {
         var a$339 = [];
         Result+="const"+"\r\n";
         TCustomDeclaration.BeginIndention(Self.ClassType);
         a$339 = Self.Variables;
         var $temp39;
         for(a$329=0,$temp39=a$339.length;a$329<$temp39;a$329++) {
            Variable$3 = a$339[a$329];
            if (Variable$3.IsConst) {
               Result = Result+TCustomDeclaration.GetAsCode$(Variable$3);
            }
         }
         TCustomDeclaration.EndIndention(Self.ClassType);
         Result+="\r\n";
      }
      if (Self.Enums.length+Self.Classes.length+Self.Interfaces.length+Self.TypeAliases.length>0) {
         var a$340 = [],
             a$341 = [],
             a$342 = [],
             a$343 = [];
         Result+="type"+"\r\n";
         TCustomDeclaration.BeginIndention(Self.ClassType);
         a$341 = Self.Enums;
         var $temp40;
         for(a$330=0,$temp40=a$341.length;a$330<$temp40;a$330++) {
            Enum$1 = a$341[a$330];
            Result+=TCustomDeclaration.GetAsCode$(Enum$1);
         }
         a$340 = Self.Classes;
         var $temp41;
         for(a$331=0,$temp41=a$340.length;a$331<$temp41;a$331++) {
            Class$2 = a$340[a$331];
            Result+=TCustomDeclaration.GetAsCode$(Class$2);
         }
         a$343 = Self.Interfaces;
         var $temp42;
         for(a$332=0,$temp42=a$343.length;a$332<$temp42;a$332++) {
            Interface$4 = a$343[a$332];
            Result+=TCustomDeclaration.GetAsCode$(Interface$4);
         }
         a$342 = Self.TypeAliases;
         var $temp43;
         for(a$333=0,$temp43=a$342.length;a$333<$temp43;a$333++) {
            TypeAlias = a$342[a$333];
            Result+=TCustomDeclaration.GetAsCode$(TypeAlias);
         }
         TCustomDeclaration.EndIndention(Self.ClassType);
      }
      if (Self.Functions.length>0) {
         var a$344 = [];
         a$344 = Self.Functions;
         var $temp44;
         for(a$334=0,$temp44=a$344.length;a$334<$temp44;a$334++) {
            Function$3 = a$344[a$334];
            Result+=TCustomDeclaration.GetAsCode$(Function$3);
         }
         Result+="\r\n";
      }
      if (Self.Variables.length-Constants>0) {
         var a$345 = [];
         Result+="var"+"\r\n";
         TCustomDeclaration.BeginIndention(Self.ClassType);
         a$345 = Self.Variables;
         var $temp45;
         for(a$335=0,$temp45=a$345.length;a$335<$temp45;a$335++) {
            Variable$4 = a$345[a$335];
            if (!Variable$4.IsConst) {
               Result = Result+TCustomDeclaration.GetAsCode$(Variable$4);
            }
         }
         TCustomDeclaration.EndIndention(Self.ClassType);
         Result+="\r\n";
      }
      a$337 = Self.Namespaces;
      var $temp46;
      for(a$336=0,$temp46=a$337.length;a$336<$temp46;a$336++) {
         Namespace$1 = a$337[a$336];
         Result+=TCustomDeclaration.GetAsCode$(Namespace$1);
      }
      Result+="\r\n";
      TCustomDeclaration.EndNamespace(Self.ClassType);
      return Result
   }
   ,Destroy:TObject.Destroy
   ,Create$10:TCustomDeclaration.Create$10
   ,GetAsCode$:function($){return $.ClassType.GetAsCode($)}
};
var TAmbientModuleDeclaration = {
   $ClassName:"TAmbientModuleDeclaration",$Parent:TCustomDeclaration
   ,$Init:function ($) {
      TCustomDeclaration.$Init($);
      $.Interfaces = [];
      $.Namespaces = [];
      $.Modules = [];
      $.Classes = [];
      $.Functions = [];
      $.TypeAliases = [];
      $.IdentifierPath = "";
      $.Enums = [];
      $.Variables = [];
   }
   ,GetAsCode:function(Self) {
      var Result = "";
      var Constants$1 = 0,
         a$346 = 0;
      var Variable$5 = null,
         a$347 = 0;
      var Variable$6 = null,
         a$348 = 0;
      var Enum$2 = null,
         a$349 = 0;
      var Class$3 = null,
         a$350 = 0;
      var Interface$5 = null,
         a$351 = 0;
      var TypeAlias$1 = null,
         a$352 = 0;
      var Module$2 = null,
         a$353 = 0;
      var Function$4 = null,
         a$354 = 0;
      var Variable$7 = null,
         a$355 = 0;
      var Namespace$2 = null;
      var a$356 = [],
          a$357 = [],
          a$358 = [];
      Result = "\/\/"+Self.IdentifierPath+"\r\n"+"\r\n";
      Constants$1 = 0;
      a$356 = Self.Variables;
      var $temp47;
      for(a$346=0,$temp47=a$356.length;a$346<$temp47;a$346++) {
         Variable$5 = a$356[a$346];
         if (Variable$5.IsConst) {
            ++Constants$1;
         }
      }
      if (Constants$1>0) {
         var a$359 = [];
         Result+="const"+"\r\n";
         TCustomDeclaration.BeginIndention(Self.ClassType);
         a$359 = Self.Variables;
         var $temp48;
         for(a$347=0,$temp48=a$359.length;a$347<$temp48;a$347++) {
            Variable$6 = a$359[a$347];
            if (Variable$6.IsConst) {
               Result = Result+TCustomDeclaration.GetAsCode$(Variable$6);
            }
         }
         TCustomDeclaration.EndIndention(Self.ClassType);
         Result+="\r\n";
      }
      if (Self.Enums.length+Self.Classes.length+Self.Interfaces.length>0) {
         var a$360 = [],
             a$361 = [],
             a$362 = [],
             a$363 = [];
         Result+="type"+"\r\n";
         TCustomDeclaration.BeginIndention(Self.ClassType);
         a$361 = Self.Enums;
         var $temp49;
         for(a$348=0,$temp49=a$361.length;a$348<$temp49;a$348++) {
            Enum$2 = a$361[a$348];
            Result+=TCustomDeclaration.GetAsCode$(Enum$2);
         }
         a$360 = Self.Classes;
         var $temp50;
         for(a$349=0,$temp50=a$360.length;a$349<$temp50;a$349++) {
            Class$3 = a$360[a$349];
            Result+=TCustomDeclaration.GetAsCode$(Class$3);
         }
         a$363 = Self.Interfaces;
         var $temp51;
         for(a$350=0,$temp51=a$363.length;a$350<$temp51;a$350++) {
            Interface$5 = a$363[a$350];
            Result+=TCustomDeclaration.GetAsCode$(Interface$5);
         }
         a$362 = Self.TypeAliases;
         var $temp52;
         for(a$351=0,$temp52=a$362.length;a$351<$temp52;a$351++) {
            TypeAlias$1 = a$362[a$351];
            Result+=TCustomDeclaration.GetAsCode$(TypeAlias$1);
         }
         TCustomDeclaration.EndIndention(Self.ClassType);
      }
      a$357 = Self.Modules;
      var $temp53;
      for(a$352=0,$temp53=a$357.length;a$352<$temp53;a$352++) {
         Module$2 = a$357[a$352];
         Result+=TCustomDeclaration.GetAsCode$(Module$2);
      }
      if (Self.Functions.length>0) {
         var a$364 = [];
         a$364 = Self.Functions;
         var $temp54;
         for(a$353=0,$temp54=a$364.length;a$353<$temp54;a$353++) {
            Function$4 = a$364[a$353];
            Result+=TCustomDeclaration.GetAsCode$(Function$4);
         }
         Result+="\r\n";
      }
      if (Self.Variables.length-Constants$1>0) {
         var a$365 = [];
         Result+="var"+"\r\n";
         TCustomDeclaration.BeginIndention(Self.ClassType);
         a$365 = Self.Variables;
         var $temp55;
         for(a$354=0,$temp55=a$365.length;a$354<$temp55;a$354++) {
            Variable$7 = a$365[a$354];
            if (!Variable$7.IsConst) {
               Result = Result+TCustomDeclaration.GetAsCode$(Variable$7);
            }
         }
         TCustomDeclaration.EndIndention(Self.ClassType);
         Result+="\r\n";
      }
      a$358 = Self.Namespaces;
      var $temp56;
      for(a$355=0,$temp56=a$358.length;a$355<$temp56;a$355++) {
         Namespace$2 = a$358[a$355];
         Result+=TCustomDeclaration.GetAsCode$(Namespace$2);
      }
      Result+="\r\n";
      return Result
   }
   ,Destroy:TObject.Destroy
   ,Create$10:TCustomDeclaration.Create$10
   ,GetAsCode$:function($){return $.ClassType.GetAsCode($)}
};
var TAmbientFunctionDeclaration = {
   $ClassName:"TAmbientFunctionDeclaration",$Parent:TNamedDeclaration
   ,$Init:function ($) {
      TNamedDeclaration.$Init($);
      $.CallSignature = null;
   }
   ,GetAsCode:function(Self) {
      var Result = "";
      var Head$3 = "";
      var Foot$3 = "";
      var OptionalParameterCount$3 = 0,
         a$366 = 0;
      var Parameter$3 = null,
         i$3 = 0;
      var a$367 = [];
      OptionalParameterCount$3 = 0;
      a$367 = Self.CallSignature.ParameterList;
      var $temp57;
      for(a$366=0,$temp57=a$367.length;a$366<$temp57;a$366++) {
         Parameter$3 = a$367[a$366];
         if (Parameter$3.IsOptional) {
            ++OptionalParameterCount$3;
         }
      }
      Head$3 = TCustomDeclaration.GetIndentionString(Self.ClassType);
      Head$3+=(Self.CallSignature.Type)?"function":"procedure";
      Head$3+=" "+Escape(Self.Name);
      Foot$3 = ";"+((OptionalParameterCount$3>0)?" overload;":"");
      if (TCustomDeclaration.GetNamespaceString(Self.ClassType)!="") {
         Foot$3+=" external '"+TCustomDeclaration.GetNamespaceString(Self.ClassType)+"."+Self.Name+"'";
      }
      Foot$3+="\r\n";
      Result = "";
      var $temp58;
      for(i$3=0,$temp58=OptionalParameterCount$3;i$3<=$temp58;i$3++) {
         Result+=Head$3+TCallSignature.GetAsCodeWithOptionalLevel$1(Self.CallSignature,i$3)+Foot$3;
      }
      return Result
   }
   ,Destroy:TObject.Destroy
   ,Create$10:TCustomDeclaration.Create$10
   ,GetAsCode$:function($){return $.ClassType.GetAsCode($)}
};
var TAmbientEnumerationDeclaration = {
   $ClassName:"TAmbientEnumerationDeclaration",$Parent:TEnumerationDeclaration
   ,$Init:function ($) {
      TEnumerationDeclaration.$Init($);
   }
   ,Destroy:TObject.Destroy
   ,Create$10:TCustomDeclaration.Create$10
   ,GetAsCode:TEnumerationDeclaration.GetAsCode
};
var TAmbientDeclaration = {
   $ClassName:"TAmbientDeclaration",$Parent:TNamedDeclaration
   ,$Init:function ($) {
      TNamedDeclaration.$Init($);
      $.Variables = [];
      $.Namespaces = [];
      $.Modules = [];
      $.Classes = [];
      $.Functions = [];
      $.Enums = [];
   }
   ,GetAsCode:function(Self) {
      var Result = "";
      var a$368 = 0;
      var Function$5 = null,
         a$369 = 0;
      var Module$3 = null,
         a$370 = 0;
      var Class$4 = null,
         a$371 = 0;
      var Variable$8 = null,
         a$372 = 0;
      var Namespace$3 = null;
      var a$373 = [],
          a$374 = [],
          a$375 = [],
          a$376 = [];
      a$374 = Self.Functions;
      var $temp59;
      for(a$368=0,$temp59=a$374.length;a$368<$temp59;a$368++) {
         Function$5 = a$374[a$368];
         Result+=TCustomDeclaration.GetAsCode$(Function$5);
      }
      a$373 = Self.Modules;
      var $temp60;
      for(a$369=0,$temp60=a$373.length;a$369<$temp60;a$369++) {
         Module$3 = a$373[a$369];
         Result+=TCustomDeclaration.GetAsCode$(Module$3);
      }
      if (Self.Classes.length>0) {
         var a$377 = [];
         Result+="type"+"\r\n";
         TCustomDeclaration.BeginIndention(Self.ClassType);
         a$377 = Self.Classes;
         var $temp61;
         for(a$370=0,$temp61=a$377.length;a$370<$temp61;a$370++) {
            Class$4 = a$377[a$370];
            Result+=TCustomDeclaration.GetAsCode$(Class$4);
         }
         TCustomDeclaration.EndIndention(Self.ClassType);
      }
      if (Self.Variables.length>0) {
         a$376 = Self.Variables;
         var $temp62;
         for(a$371=0,$temp62=a$376.length;a$371<$temp62;a$371++) {
            Variable$8 = a$376[a$371];
            Result+=TCustomDeclaration.GetAsCode$(Variable$8);
         }
      }
      a$375 = Self.Namespaces;
      var $temp63;
      for(a$372=0,$temp63=a$375.length;a$372<$temp63;a$372++) {
         Namespace$3 = a$375[a$372];
         Result+=TCustomDeclaration.GetAsCode$(Namespace$3);
      }
      return Result
   }
   ,Destroy:TObject.Destroy
   ,Create$10:TCustomDeclaration.Create$10
   ,GetAsCode$:function($){return $.ClassType.GetAsCode($)}
};
var TAmbientConstructorDeclaration = {
   $ClassName:"TAmbientConstructorDeclaration",$Parent:TAmbientBodyElement
   ,$Init:function ($) {
      TAmbientBodyElement.$Init($);
      $.ParameterList = [];
   }
   ,GetAsCode:function(Self) {
      var Result = "";
      var Index$10 = 0;
      Result = TCustomDeclaration.GetIndentionString(Self.ClassType)+"constructor Create";
      if (Self.ParameterList.length>0) {
         Result+="(";
         var $temp64;
         for(Index$10=0,$temp64=(Self.ParameterList.length-1);Index$10<$temp64;Index$10++) {
            Result+=TFunctionParameter.GetAsCodeOmitType$1(Self.ParameterList[Index$10],false)+"; ";
         }
         Result+=TFunctionParameter.GetAsCodeOmitType$1(Self.ParameterList[(Self.ParameterList.length-1)],false)+")";
         Result+=")";
      }
      Result+=";"+"\r\n";
      return Result
   }
   ,Destroy:TObject.Destroy
   ,Create$10:TCustomDeclaration.Create$10
   ,GetAsCode$:function($){return $.ClassType.GetAsCode($)}
};
var TAmbientClassDeclaration = {
   $ClassName:"TAmbientClassDeclaration",$Parent:TCustomDeclaration
   ,$Init:function ($) {
      TCustomDeclaration.$Init($);
      $.TypeParameters = [];
      $.Members = [];
      $.Name = "";
      $.Extends = [];
      $.Implements = [];
   }
   ,GetAsCode:function(Self) {
      var Result = "";
      var Index$11 = 0;
      var LastVisibility = 0,
         a$378 = 0;
      var Member$3 = null,
         CurrentVisibility = 0;
      var a$379 = [];
      Result+=TCustomDeclaration.GetIndentionString(Self.ClassType)+"J"+Self.Name+" = class external '"+Self.Name+"'";
      if (Self.Extends.length>0) {
         Result+="(";
         Result+=TCustomDeclaration.GetAsCode$(Self.Extends[0]);
         var $temp65;
         for(Index$11=0+1,$temp65=Self.Extends.length;Index$11<$temp65;Index$11++) {
            Result+=", "+TCustomDeclaration.GetAsCode$(Self.Extends[Index$11]);
         }
         Result+=")";
      }
      Result+="\r\n";
      LastVisibility = 0;
      TCustomDeclaration.BeginIndention(Self.ClassType);
      a$379 = Self.Members;
      var $temp66;
      for(a$378=0,$temp66=a$379.length;a$378<$temp66;a$378++) {
         Member$3 = a$379[a$378];
         CurrentVisibility = ($Is(Member$3,TAmbientPropertyMemberDeclaration))?$As(Member$3,TAmbientPropertyMemberDeclaration).Visibility:0;
         if (LastVisibility!=CurrentVisibility) {
            TCustomDeclaration.EndIndention(Self.ClassType);
            Result+=TCustomDeclaration.GetIndentionString(Self.ClassType);
            switch (CurrentVisibility) {
               case 0 :
                  Result+="public"+"\r\n";
                  break;
               case 1 :
                  Result+="protected"+"\r\n";
                  break;
               case 2 :
                  Result+="private"+"\r\n";
                  break;
            }
            TCustomDeclaration.BeginIndention(Self.ClassType);
            LastVisibility = CurrentVisibility;
         }
         Result+=TCustomDeclaration.GetAsCode$(Member$3);
      }
      TCustomDeclaration.EndIndention(Self.ClassType);
      Result+=TCustomDeclaration.GetIndentionString(Self.ClassType)+"end;"+"\r\n"+"\r\n";
      return Result
   }
   ,Destroy:TObject.Destroy
   ,Create$10:TCustomDeclaration.Create$10
   ,GetAsCode$:function($){return $.ClassType.GetAsCode($)}
};
var TAmbientBinding = {
   $ClassName:"TAmbientBinding",$Parent:TNamedDeclaration
   ,$Init:function ($) {
      TNamedDeclaration.$Init($);
      $.Type = null;
   }
   ,GetAsCode:function(Self) {
      var Result = "";
      Result = Self.Name+": "+TCustomDeclaration.GetAsCode$(Self.Type);
      return Result
   }
   ,Destroy:TObject.Destroy
   ,Create$10:TCustomDeclaration.Create$10
   ,GetAsCode$:function($){return $.ClassType.GetAsCode($)}
};
var TAccessibilityModifier = [ "amPublic", "amPrivate", "amProtected" ];
function IsIdenticalParameterType(A$1, B) {
   var Result = false;
   Result = (!(A$1.Type!==null) != !(A$1.Type!==null));
   if (Result&&(A$1.Type!==null)) {
      Result = TCustomDeclaration.GetAsCode$(A$1.Type)==TCustomDeclaration.GetAsCode$(B.Type);
   }
   return Result
};
function IsIdenticalFunctionParameterType(A$2, B$1) {
   var Result = false;
   Result = (!(A$2.Type!==null) != !(A$2.Type!==null));
   if (Result&&(A$2.Type!==null)) {
      Result = TCustomDeclaration.GetAsCode$(A$2.Type)==TCustomDeclaration.GetAsCode$(B$1.Type);
   }
   return Result
};
function Escape(Name$15) {
   var Result = "";
   Result = Name$15;
   if ((["abstract","class","const","constructor","default","div","end","export","external","function","interface","label","object","private","property","protected","public","string","type","unit","uses"].indexOf((Name$15).toLowerCase())>=0)) {
      Result = "&"+Result;
   }
   if ((["length","include","exclude"].indexOf((Name$15).toLowerCase())>=0)) {
      Result = "_"+Result;
   }
   return Result
};
var TypeScriptExport = null;
var TypeScriptExport = require("typescript");
var FIndentionLevel = 0;
var FNamespaces = [];
var FileSystem = null;
var FileSystem = fs();
TranslateFile$1("TypeScriptDefs\/space-pen");

